// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-4.2.0/src/analyzer/protocol/http/functions.bif (plugin mode).


#include "functions.bif.h"
#include "zeek/Func.h"


#line 2 "functions.bif"

#include "zeek/analyzer/protocol/http/HTTP.h"

#line 13 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::skip_http_entity_data_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 14 "functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		reporter->Error("skip_http_entity_data() takes exactly 2 argument(s)");
		return nullptr;
		}
	zeek::Connection* c = (zeek::Connection*) ((*BiF_ARGS)[0].get()->AsRecordVal()->GetOrigin());
	int is_orig = (int) ((*BiF_ARGS)[1].get()->AsBool());

#line 14 "functions.bif"

	analyzer::ID id = zeek::event_mgr.CurrentAnalyzer();
	if ( id )
		{
		zeek::analyzer::Analyzer* ha = c->FindAnalyzer(id);

		if ( ha )
			{
			if ( ha->IsAnalyzer("HTTP") )
				static_cast<zeek::analyzer::http::HTTP_Analyzer*>(ha)->SkipEntityData(is_orig);
			else
				reporter->Error("non-HTTP analyzer associated with connection record");
			}
		else
			reporter->Error("could not find analyzer for skip_http_entity_data");

		}
	else
		reporter->Error("no analyzer associated with connection record");

	return nullptr;
	} // end of BifFunc::skip_http_entity_data

#line 35 "functions.bif"

#line 50 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::unescape_URI_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 51 "functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		reporter->Error("unescape_URI() takes exactly 1 argument(s)");
		return nullptr;
		}
	zeek::StringVal* URI = (zeek::StringVal*) ((*BiF_ARGS)[0].get()->AsStringVal());

#line 51 "functions.bif"

	const u_char* line = URI->Bytes();
	const u_char* const line_end = line + URI->Len();

	return zeek::make_intrusive<zeek::StringVal>(zeek::analyzer::http::unescape_URI(line, line_end, 0));
	} // end of BifFunc::unescape_URI

#line 56 "functions.bif"
