// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-4.2.0/src/analyzer/protocol/tcp/functions.bif (plugin mode).


#include "functions.bif.h"
#include "zeek/Func.h"


#line 2 "functions.bif"

#include "zeek/File.h"
#include "zeek/session/Manager.h"
#include "zeek/Reporter.h"
#include "zeek/analyzer/protocol/tcp/TCP.h"

#line 19 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::get_orig_seq_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 20 "functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		reporter->Error("get_orig_seq() takes exactly 1 argument(s)");
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 20 "functions.bif"

	zeek::Connection* c = zeek::session_mgr->FindConnection(cid);
	if ( ! c )
		return zeek::val_mgr->Count(0);

	if ( c->ConnTransport() != TRANSPORT_TCP )
		return zeek::val_mgr->Count(0);

	zeek::analyzer::Analyzer* tc = c->FindAnalyzer("TCP");
	if ( tc )
		return zeek::val_mgr->Count(static_cast<zeek::packet_analysis::TCP::TCPSessionAdapter*>(tc)->OrigSeq());
	else
		{
		reporter->Error("connection does not have TCP analyzer");
		return zeek::val_mgr->Count(0);
		}
	} // end of BifFunc::get_orig_seq

#line 36 "functions.bif"

#line 48 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::get_resp_seq_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 49 "functions.bif"
{
	if ( BiF_ARGS->size() != 1 )
		{
		reporter->Error("get_resp_seq() takes exactly 1 argument(s)");
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());

#line 49 "functions.bif"

	zeek::Connection* c = zeek::session_mgr->FindConnection(cid);
	if ( ! c )
		return zeek::val_mgr->Count(0);

	if ( c->ConnTransport() != TRANSPORT_TCP )
		return zeek::val_mgr->Count(0);

	zeek::analyzer::Analyzer* tc = c->FindAnalyzer("TCP");
	if ( tc )
		return zeek::val_mgr->Count(static_cast<zeek::packet_analysis::TCP::TCPSessionAdapter*>(tc)->RespSeq());
	else
		{
		reporter->Error("connection does not have TCP analyzer");
		return zeek::val_mgr->Count(0);
		}
	} // end of BifFunc::get_resp_seq

#line 65 "functions.bif"

#line 98 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::set_contents_file_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 99 "functions.bif"
{
	if ( BiF_ARGS->size() != 3 )
		{
		reporter->Error("set_contents_file() takes exactly 3 argument(s)");
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());
	bro_uint_t direction = (bro_uint_t) ((*BiF_ARGS)[1].get()->AsCount());
	zeek::File* f = (zeek::File*) ((*BiF_ARGS)[2].get()->AsFile());

#line 99 "functions.bif"

	zeek::Connection* c = zeek::session_mgr->FindConnection(cid);
	if ( ! c )
		return zeek::val_mgr->False();

	c->GetSessionAdapter()->SetContentsFile(direction, {zeek::NewRef{}, f});
	return zeek::val_mgr->True();
	} // end of BifFunc::set_contents_file

#line 106 "functions.bif"

#line 121 "functions.bif"
zeek::detail::BifReturnVal zeek::BifFunc::get_contents_file_bif(zeek::detail::Frame* frame, const zeek::Args* BiF_ARGS)
	
#line 122 "functions.bif"
{
	if ( BiF_ARGS->size() != 2 )
		{
		reporter->Error("get_contents_file() takes exactly 2 argument(s)");
		return nullptr;
		}
	zeek::Val* cid = (zeek::Val*) ((*BiF_ARGS)[0].get());
	bro_uint_t direction = (bro_uint_t) ((*BiF_ARGS)[1].get()->AsCount());

#line 122 "functions.bif"

	zeek::Connection* c = zeek::session_mgr->FindConnection(cid);

	if ( c )
		{
		auto cf = c->GetSessionAdapter()->GetContentsFile(direction);

		if ( cf )
			return zeek::make_intrusive<zeek::FileVal>(std::move(cf));
		}

	// Return some sort of error value.
	if ( ! c )
		zeek::emit_builtin_error("unknown connection id in get_contents_file()", cid);
	else
		zeek::emit_builtin_error("no contents file for given direction");

	return zeek::make_intrusive<zeek::FileVal>(zeek::make_intrusive<zeek::File>(stderr, "-", "w"));
	} // end of BifFunc::get_contents_file

#line 140 "functions.bif"
