/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "parse.y"

// See the file "COPYING" in the main distribution directory for copyright.
#line 78 "parse.y"

#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include <set>
#include <string>

#include "zeek/input.h"
#include "zeek/ZeekList.h"
#include "zeek/Desc.h"
#include "zeek/Expr.h"
#include "zeek/Func.h"
#include "zeek/Stmt.h"
#include "zeek/Val.h"
#include "zeek/Var.h"
#include "zeek/RE.h"
#include "zeek/Scope.h"
#include "zeek/Reporter.h"
#include "zeek/ScriptCoverageManager.h"
#include "zeek/zeekygen/Manager.h"
#include "zeek/module_util.h"
#include "zeek/IntrusivePtr.h"
#include "zeek/script_opt/IDOptInfo.h"

extern const char* filename;  // Absolute path of file currently being parsed.
extern const char* last_filename; // Absolute path of last file parsed.
extern const char* last_tok_filename;
extern const char* last_last_tok_filename;

extern int conditional_epoch; // let's us track embedded conditionals

// Whether the file we're currently parsing includes @if conditionals.
extern bool current_file_has_conditionals;

YYLTYPE GetCurrentLocation();
extern int yyerror(const char[]);
extern int brolex();

#define YYLLOC_DEFAULT(Current, Rhs, N) \
	(Current) = (Rhs)[(N)];

using namespace zeek;
using namespace zeek::detail;

// Part of the module facility: while parsing, keep track of which
// module to put things in.
std::string zeek::detail::current_module = GLOBAL_MODULE_NAME;

bool is_export = false; // true if in an export {} block

// When parsing an expression for the debugger, where to put the result
// (obviously not reentrant).
extern Expr* g_curr_debug_expr;
extern bool in_debug;
extern const char* g_curr_debug_error;

static int in_when_cond = 0;
static int in_hook = 0;
int in_init = 0;
int in_record = 0;
static int in_record_redef = 0;
static int in_enum_redef = 0;
bool resolving_global_ID = false;
bool defining_global_ID = false;
std::vector<int> saved_in_init;

std::vector<std::set<const ID*>> locals_at_this_scope;
static std::unordered_set<const ID*> out_of_scope_locals;
static std::unordered_set<const ID*> warned_about_locals;

static Location func_hdr_location;
static int func_hdr_cond_epoch = 0;
EnumType* cur_enum_type = nullptr;
static ID* cur_decl_type_id = nullptr;

static void parse_new_enum(void)
	{
	// Starting a new enum definition.
	assert(cur_enum_type == nullptr);

	if ( cur_decl_type_id )
		{
		auto name = make_full_var_name(current_module.c_str(), cur_decl_type_id->Name());
		cur_enum_type = new EnumType(name);
		}
	else
		reporter->FatalError("incorrect syntax for enum type declaration");
	}

static void parse_redef_enum(ID* id)
	{
	// Redef an enum. id points to the enum to be redefined.
	// Let cur_enum_type point to it.
	assert(cur_enum_type == nullptr);

	// abort on errors; enums need to be accessible to continue parsing
	if ( ! id->GetType() )
		reporter->FatalError("unknown enum identifier \"%s\"", id->Name());
	else
		{
		if ( ! id->GetType() || id->GetType()->Tag() != TYPE_ENUM )
			reporter->FatalError("identifier \"%s\" is not an enum", id->Name());
		cur_enum_type = id->GetType()->AsEnumType();
		}
	}

static void extend_record(ID* id, std::unique_ptr<type_decl_list> fields,
                          std::unique_ptr<std::vector<AttrPtr>> attrs)
	{
	const auto& types = Type::Aliases(id->Name());

	if ( types.empty() )
		{
		id->Error("failed to redef record: no types found in alias map");
		return;
		}

	bool add_log_attr = false;

	if ( attrs )
		for ( const auto& at : *attrs )
			if ( at->Tag() == ATTR_LOG )
				{
				add_log_attr = true;
				break;
				}

	for ( const auto& t : types )
		{
		auto error = t->AsRecordType()->AddFields(*fields, add_log_attr);

		if ( error )
			{
			id->Error(error);
			break;
			}
		}
	}

static AttributesPtr
make_attributes(std::vector<AttrPtr>* attrs,
                TypePtr t, bool in_record, bool is_global)
	{
	if ( ! attrs )
		return nullptr;

	auto rval = make_intrusive<Attributes>(std::move(*attrs), std::move(t),
	                                       in_record, is_global);
	delete attrs;
	return rval;
	}

static bool expr_is_table_type_name(const Expr* expr)
	{
	if ( expr->Tag() != EXPR_NAME )
		return false;

	const auto& type = expr->GetType();

	if ( type->IsTable() )
		return true;

	if ( type->Tag() == TYPE_TYPE )
		return type->AsTypeType()->GetType()->IsTable();

	return false;
	}

static void build_global(ID* id, Type* t, InitClass ic, Expr* e,
                         std::vector<AttrPtr>* attrs, DeclType dt)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	add_global(id_ptr, std::move(t_ptr), ic, e_ptr, std::move(attrs_ptr), dt);

	id->GetOptInfo()->AddInitExpr(e_ptr);

	if ( dt == VAR_REDEF )
		zeekygen_mgr->Redef(id, ::filename, ic, std::move(e_ptr));
	else
		zeekygen_mgr->Identifier(std::move(id_ptr));
	}

static StmtPtr build_local(ID* id, Type* t, InitClass ic, Expr* e,
                           std::vector<AttrPtr>* attrs, DeclType dt,
                           bool do_coverage)
	{
	IDPtr id_ptr{AdoptRef{}, id};
	TypePtr t_ptr{AdoptRef{}, t};
	ExprPtr e_ptr{AdoptRef{}, e};

	auto attrs_ptr = attrs ? std::make_unique<std::vector<AttrPtr>>(*attrs) : nullptr;

	auto init = add_local(std::move(id_ptr), std::move(t_ptr), ic,
	                      e_ptr, std::move(attrs_ptr), dt);

	id->GetOptInfo()->AddInitExpr(std::move(e_ptr));

	if ( do_coverage )
		script_coverage_mgr.AddStmt(init.get());

	return init;
	}

#line 284 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "broparse.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ADD = 3,                    /* TOK_ADD  */
  YYSYMBOL_TOK_ADD_TO = 4,                 /* TOK_ADD_TO  */
  YYSYMBOL_TOK_ADDR = 5,                   /* TOK_ADDR  */
  YYSYMBOL_TOK_ANY = 6,                    /* TOK_ANY  */
  YYSYMBOL_TOK_ATENDIF = 7,                /* TOK_ATENDIF  */
  YYSYMBOL_TOK_ATELSE = 8,                 /* TOK_ATELSE  */
  YYSYMBOL_TOK_ATIF = 9,                   /* TOK_ATIF  */
  YYSYMBOL_TOK_ATIFDEF = 10,               /* TOK_ATIFDEF  */
  YYSYMBOL_TOK_ATIFNDEF = 11,              /* TOK_ATIFNDEF  */
  YYSYMBOL_TOK_BOOL = 12,                  /* TOK_BOOL  */
  YYSYMBOL_TOK_BREAK = 13,                 /* TOK_BREAK  */
  YYSYMBOL_TOK_CASE = 14,                  /* TOK_CASE  */
  YYSYMBOL_TOK_OPTION = 15,                /* TOK_OPTION  */
  YYSYMBOL_TOK_CONST = 16,                 /* TOK_CONST  */
  YYSYMBOL_TOK_CONSTANT = 17,              /* TOK_CONSTANT  */
  YYSYMBOL_TOK_COPY = 18,                  /* TOK_COPY  */
  YYSYMBOL_TOK_COUNT = 19,                 /* TOK_COUNT  */
  YYSYMBOL_TOK_DEFAULT = 20,               /* TOK_DEFAULT  */
  YYSYMBOL_TOK_DELETE = 21,                /* TOK_DELETE  */
  YYSYMBOL_TOK_DOUBLE = 22,                /* TOK_DOUBLE  */
  YYSYMBOL_TOK_ELSE = 23,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_ENUM = 24,                  /* TOK_ENUM  */
  YYSYMBOL_TOK_EVENT = 25,                 /* TOK_EVENT  */
  YYSYMBOL_TOK_EXPORT = 26,                /* TOK_EXPORT  */
  YYSYMBOL_TOK_FALLTHROUGH = 27,           /* TOK_FALLTHROUGH  */
  YYSYMBOL_TOK_FILE = 28,                  /* TOK_FILE  */
  YYSYMBOL_TOK_FOR = 29,                   /* TOK_FOR  */
  YYSYMBOL_TOK_FUNCTION = 30,              /* TOK_FUNCTION  */
  YYSYMBOL_TOK_GLOBAL = 31,                /* TOK_GLOBAL  */
  YYSYMBOL_TOK_HOOK = 32,                  /* TOK_HOOK  */
  YYSYMBOL_TOK_ID = 33,                    /* TOK_ID  */
  YYSYMBOL_TOK_IF = 34,                    /* TOK_IF  */
  YYSYMBOL_TOK_INT = 35,                   /* TOK_INT  */
  YYSYMBOL_TOK_INTERVAL = 36,              /* TOK_INTERVAL  */
  YYSYMBOL_TOK_LIST = 37,                  /* TOK_LIST  */
  YYSYMBOL_TOK_LOCAL = 38,                 /* TOK_LOCAL  */
  YYSYMBOL_TOK_MODULE = 39,                /* TOK_MODULE  */
  YYSYMBOL_TOK_NEXT = 40,                  /* TOK_NEXT  */
  YYSYMBOL_TOK_OF = 41,                    /* TOK_OF  */
  YYSYMBOL_TOK_OPAQUE = 42,                /* TOK_OPAQUE  */
  YYSYMBOL_TOK_PATTERN = 43,               /* TOK_PATTERN  */
  YYSYMBOL_TOK_PATTERN_END = 44,           /* TOK_PATTERN_END  */
  YYSYMBOL_TOK_PATTERN_TEXT = 45,          /* TOK_PATTERN_TEXT  */
  YYSYMBOL_TOK_PORT = 46,                  /* TOK_PORT  */
  YYSYMBOL_TOK_PRINT = 47,                 /* TOK_PRINT  */
  YYSYMBOL_TOK_RECORD = 48,                /* TOK_RECORD  */
  YYSYMBOL_TOK_REDEF = 49,                 /* TOK_REDEF  */
  YYSYMBOL_TOK_REMOVE_FROM = 50,           /* TOK_REMOVE_FROM  */
  YYSYMBOL_TOK_RETURN = 51,                /* TOK_RETURN  */
  YYSYMBOL_TOK_SCHEDULE = 52,              /* TOK_SCHEDULE  */
  YYSYMBOL_TOK_SET = 53,                   /* TOK_SET  */
  YYSYMBOL_TOK_STRING = 54,                /* TOK_STRING  */
  YYSYMBOL_TOK_SUBNET = 55,                /* TOK_SUBNET  */
  YYSYMBOL_TOK_SWITCH = 56,                /* TOK_SWITCH  */
  YYSYMBOL_TOK_TABLE = 57,                 /* TOK_TABLE  */
  YYSYMBOL_TOK_TIME = 58,                  /* TOK_TIME  */
  YYSYMBOL_TOK_TIMEOUT = 59,               /* TOK_TIMEOUT  */
  YYSYMBOL_TOK_TIMER = 60,                 /* TOK_TIMER  */
  YYSYMBOL_TOK_TYPE = 61,                  /* TOK_TYPE  */
  YYSYMBOL_TOK_UNION = 62,                 /* TOK_UNION  */
  YYSYMBOL_TOK_VECTOR = 63,                /* TOK_VECTOR  */
  YYSYMBOL_TOK_WHEN = 64,                  /* TOK_WHEN  */
  YYSYMBOL_TOK_WHILE = 65,                 /* TOK_WHILE  */
  YYSYMBOL_TOK_AS = 66,                    /* TOK_AS  */
  YYSYMBOL_TOK_IS = 67,                    /* TOK_IS  */
  YYSYMBOL_TOK_ATTR_ADD_FUNC = 68,         /* TOK_ATTR_ADD_FUNC  */
  YYSYMBOL_TOK_ATTR_DEFAULT = 69,          /* TOK_ATTR_DEFAULT  */
  YYSYMBOL_TOK_ATTR_OPTIONAL = 70,         /* TOK_ATTR_OPTIONAL  */
  YYSYMBOL_TOK_ATTR_REDEF = 71,            /* TOK_ATTR_REDEF  */
  YYSYMBOL_TOK_ATTR_DEL_FUNC = 72,         /* TOK_ATTR_DEL_FUNC  */
  YYSYMBOL_TOK_ATTR_EXPIRE_FUNC = 73,      /* TOK_ATTR_EXPIRE_FUNC  */
  YYSYMBOL_TOK_ATTR_EXPIRE_CREATE = 74,    /* TOK_ATTR_EXPIRE_CREATE  */
  YYSYMBOL_TOK_ATTR_EXPIRE_READ = 75,      /* TOK_ATTR_EXPIRE_READ  */
  YYSYMBOL_TOK_ATTR_EXPIRE_WRITE = 76,     /* TOK_ATTR_EXPIRE_WRITE  */
  YYSYMBOL_TOK_ATTR_RAW_OUTPUT = 77,       /* TOK_ATTR_RAW_OUTPUT  */
  YYSYMBOL_TOK_ATTR_ON_CHANGE = 78,        /* TOK_ATTR_ON_CHANGE  */
  YYSYMBOL_TOK_ATTR_BROKER_STORE = 79,     /* TOK_ATTR_BROKER_STORE  */
  YYSYMBOL_TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX = 80, /* TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX  */
  YYSYMBOL_TOK_ATTR_BACKEND = 81,          /* TOK_ATTR_BACKEND  */
  YYSYMBOL_TOK_ATTR_PRIORITY = 82,         /* TOK_ATTR_PRIORITY  */
  YYSYMBOL_TOK_ATTR_LOG = 83,              /* TOK_ATTR_LOG  */
  YYSYMBOL_TOK_ATTR_ERROR_HANDLER = 84,    /* TOK_ATTR_ERROR_HANDLER  */
  YYSYMBOL_TOK_ATTR_TYPE_COLUMN = 85,      /* TOK_ATTR_TYPE_COLUMN  */
  YYSYMBOL_TOK_ATTR_DEPRECATED = 86,       /* TOK_ATTR_DEPRECATED  */
  YYSYMBOL_TOK_ATTR_IS_ASSIGNED = 87,      /* TOK_ATTR_IS_ASSIGNED  */
  YYSYMBOL_TOK_ATTR_IS_USED = 88,          /* TOK_ATTR_IS_USED  */
  YYSYMBOL_TOK_DEBUG = 89,                 /* TOK_DEBUG  */
  YYSYMBOL_TOK_NO_TEST = 90,               /* TOK_NO_TEST  */
  YYSYMBOL_91_ = 91,                       /* ','  */
  YYSYMBOL_92_ = 92,                       /* '='  */
  YYSYMBOL_93_ = 93,                       /* '?'  */
  YYSYMBOL_94_ = 94,                       /* ':'  */
  YYSYMBOL_TOK_OR_OR = 95,                 /* TOK_OR_OR  */
  YYSYMBOL_TOK_AND_AND = 96,               /* TOK_AND_AND  */
  YYSYMBOL_97_ = 97,                       /* '<'  */
  YYSYMBOL_98_ = 98,                       /* '>'  */
  YYSYMBOL_TOK_LE = 99,                    /* TOK_LE  */
  YYSYMBOL_TOK_GE = 100,                   /* TOK_GE  */
  YYSYMBOL_TOK_EQ = 101,                   /* TOK_EQ  */
  YYSYMBOL_TOK_NE = 102,                   /* TOK_NE  */
  YYSYMBOL_TOK_IN = 103,                   /* TOK_IN  */
  YYSYMBOL_TOK_NOT_IN = 104,               /* TOK_NOT_IN  */
  YYSYMBOL_105_ = 105,                     /* '|'  */
  YYSYMBOL_106_ = 106,                     /* '^'  */
  YYSYMBOL_107_ = 107,                     /* '&'  */
  YYSYMBOL_108_ = 108,                     /* '+'  */
  YYSYMBOL_109_ = 109,                     /* '-'  */
  YYSYMBOL_110_ = 110,                     /* '*'  */
  YYSYMBOL_111_ = 111,                     /* '/'  */
  YYSYMBOL_112_ = 112,                     /* '%'  */
  YYSYMBOL_TOK_INCR = 113,                 /* TOK_INCR  */
  YYSYMBOL_TOK_DECR = 114,                 /* TOK_DECR  */
  YYSYMBOL_115_ = 115,                     /* '!'  */
  YYSYMBOL_116_ = 116,                     /* '~'  */
  YYSYMBOL_117_ = 117,                     /* '$'  */
  YYSYMBOL_118_ = 118,                     /* '['  */
  YYSYMBOL_119_ = 119,                     /* ']'  */
  YYSYMBOL_120_ = 120,                     /* '('  */
  YYSYMBOL_121_ = 121,                     /* ')'  */
  YYSYMBOL_TOK_HAS_FIELD = 122,            /* TOK_HAS_FIELD  */
  YYSYMBOL_TOK_HAS_ATTR = 123,             /* TOK_HAS_ATTR  */
  YYSYMBOL_124_ = 124,                     /* '{'  */
  YYSYMBOL_125_ = 125,                     /* '}'  */
  YYSYMBOL_126_ = 126,                     /* ';'  */
  YYSYMBOL_YYACCEPT = 127,                 /* $accept  */
  YYSYMBOL_zeek = 128,                     /* zeek  */
  YYSYMBOL_129_1 = 129,                    /* $@1  */
  YYSYMBOL_decl_list = 130,                /* decl_list  */
  YYSYMBOL_opt_expr = 131,                 /* opt_expr  */
  YYSYMBOL_when_condition = 132,           /* when_condition  */
  YYSYMBOL_133_2 = 133,                    /* $@2  */
  YYSYMBOL_134_3 = 134,                    /* $@3  */
  YYSYMBOL_expr = 135,                     /* expr  */
  YYSYMBOL_136_4 = 136,                    /* $@4  */
  YYSYMBOL_137_5 = 137,                    /* $@5  */
  YYSYMBOL_138_6 = 138,                    /* $@6  */
  YYSYMBOL_139_7 = 139,                    /* $@7  */
  YYSYMBOL_140_8 = 140,                    /* $@8  */
  YYSYMBOL_141_9 = 141,                    /* $@9  */
  YYSYMBOL_142_10 = 142,                   /* $@10  */
  YYSYMBOL_expr_list = 143,                /* expr_list  */
  YYSYMBOL_opt_expr_list = 144,            /* opt_expr_list  */
  YYSYMBOL_enum_body = 145,                /* enum_body  */
  YYSYMBOL_enum_body_list = 146,           /* enum_body_list  */
  YYSYMBOL_enum_body_elem = 147,           /* enum_body_elem  */
  YYSYMBOL_type = 148,                     /* type  */
  YYSYMBOL_149_11 = 149,                   /* $@11  */
  YYSYMBOL_150_12 = 150,                   /* $@12  */
  YYSYMBOL_151_13 = 151,                   /* $@13  */
  YYSYMBOL_type_list = 152,                /* type_list  */
  YYSYMBOL_type_decl_list = 153,           /* type_decl_list  */
  YYSYMBOL_type_decl = 154,                /* type_decl  */
  YYSYMBOL_formal_args = 155,              /* formal_args  */
  YYSYMBOL_formal_args_decl_list = 156,    /* formal_args_decl_list  */
  YYSYMBOL_formal_args_decl = 157,         /* formal_args_decl  */
  YYSYMBOL_decl = 158,                     /* decl  */
  YYSYMBOL_159_14 = 159,                   /* $@14  */
  YYSYMBOL_160_15 = 160,                   /* $@15  */
  YYSYMBOL_161_16 = 161,                   /* $@16  */
  YYSYMBOL_162_17 = 162,                   /* $@17  */
  YYSYMBOL_163_18 = 163,                   /* $@18  */
  YYSYMBOL_164_19 = 164,                   /* $@19  */
  YYSYMBOL_165_20 = 165,                   /* $@20  */
  YYSYMBOL_conditional_list = 166,         /* conditional_list  */
  YYSYMBOL_conditional = 167,              /* conditional  */
  YYSYMBOL_func_hdr = 168,                 /* func_hdr  */
  YYSYMBOL_func_body = 169,                /* func_body  */
  YYSYMBOL_170_21 = 170,                   /* $@21  */
  YYSYMBOL_171_22 = 171,                   /* $@22  */
  YYSYMBOL_lambda_body = 172,              /* lambda_body  */
  YYSYMBOL_173_23 = 173,                   /* $@23  */
  YYSYMBOL_174_24 = 174,                   /* $@24  */
  YYSYMBOL_anonymous_function = 175,       /* anonymous_function  */
  YYSYMBOL_begin_lambda = 176,             /* begin_lambda  */
  YYSYMBOL_opt_captures = 177,             /* opt_captures  */
  YYSYMBOL_capture_list = 178,             /* capture_list  */
  YYSYMBOL_capture = 179,                  /* capture  */
  YYSYMBOL_opt_deep = 180,                 /* opt_deep  */
  YYSYMBOL_func_params = 181,              /* func_params  */
  YYSYMBOL_opt_type = 182,                 /* opt_type  */
  YYSYMBOL_init_class = 183,               /* init_class  */
  YYSYMBOL_opt_init = 184,                 /* opt_init  */
  YYSYMBOL_185_25 = 185,                   /* $@25  */
  YYSYMBOL_186_26 = 186,                   /* $@26  */
  YYSYMBOL_init = 187,                     /* init  */
  YYSYMBOL_index_slice = 188,              /* index_slice  */
  YYSYMBOL_opt_attr = 189,                 /* opt_attr  */
  YYSYMBOL_attr_list = 190,                /* attr_list  */
  YYSYMBOL_attr = 191,                     /* attr  */
  YYSYMBOL_stmt = 192,                     /* stmt  */
  YYSYMBOL_193_27 = 193,                   /* $@27  */
  YYSYMBOL_stmt_list = 194,                /* stmt_list  */
  YYSYMBOL_event = 195,                    /* event  */
  YYSYMBOL_case_list = 196,                /* case_list  */
  YYSYMBOL_case = 197,                     /* case  */
  YYSYMBOL_case_type_list = 198,           /* case_type_list  */
  YYSYMBOL_case_type = 199,                /* case_type  */
  YYSYMBOL_for_head = 200,                 /* for_head  */
  YYSYMBOL_local_id_list = 201,            /* local_id_list  */
  YYSYMBOL_local_id = 202,                 /* local_id  */
  YYSYMBOL_global_id = 203,                /* global_id  */
  YYSYMBOL_204_28 = 204,                   /* $@28  */
  YYSYMBOL_def_global_id = 205,            /* def_global_id  */
  YYSYMBOL_206_29 = 206,                   /* $@29  */
  YYSYMBOL_207_30 = 207,                   /* $@30  */
  YYSYMBOL_event_id = 208,                 /* event_id  */
  YYSYMBOL_209_31 = 209,                   /* $@31  */
  YYSYMBOL_global_or_event_id = 210,       /* global_or_event_id  */
  YYSYMBOL_resolve_id = 211,               /* resolve_id  */
  YYSYMBOL_opt_no_test = 212,              /* opt_no_test  */
  YYSYMBOL_opt_no_test_block = 213,        /* opt_no_test_block  */
  YYSYMBOL_opt_deprecated = 214            /* opt_deprecated  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3138

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  127
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  272
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  743

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   357


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by brolex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by brolex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   115,     2,     2,   117,   112,   107,     2,
     120,   121,   110,   108,    91,   109,     2,   111,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    94,   126,
      97,    92,    98,    93,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   118,     2,   119,   106,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   124,   105,   125,   116,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    95,    96,    99,   100,
     101,   102,   103,   104,   113,   114,   122,   123
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   318,   318,   333,   333,   340,   341,   345,   348,   352,
     352,   352,   357,   363,   369,   375,   381,   387,   393,   429,
     435,   441,   447,   453,   459,   465,   471,   477,   483,   489,
     495,   501,   507,   513,   519,   525,   531,   537,   543,   549,
     561,   570,   579,   581,   587,   594,   593,   603,   609,   617,
     642,   649,   655,   655,   655,   663,   670,   677,   683,   676,
     726,   726,   739,   745,   748,   754,   819,   825,   825,   839,
     846,   852,   860,   866,   874,   876,   880,   886,   894,   896,
     905,   918,   926,   936,   941,   946,   951,   956,   961,   966,
     971,   976,   981,   986,   991,   996,  1001,  1007,  1014,  1016,
    1013,  1023,  1030,  1030,  1037,  1045,  1053,  1059,  1065,  1071,
    1077,  1083,  1089,  1095,  1115,  1117,  1125,  1130,  1136,  1149,
    1151,  1154,  1158,  1160,  1162,  1167,  1176,  1182,  1182,  1185,
    1190,  1195,  1200,  1206,  1205,  1214,  1216,  1218,  1213,  1231,
    1230,  1242,  1241,  1248,  1251,  1252,  1256,  1258,  1260,  1262,
    1264,  1269,  1278,  1292,  1301,  1312,  1322,  1311,  1342,  1348,
    1341,  1374,  1379,  1406,  1409,  1413,  1415,  1423,  1450,  1453,
    1457,  1459,  1464,  1467,  1471,  1472,  1473,  1474,  1478,  1478,
    1478,  1481,  1485,  1487,  1489,  1493,  1517,  1519,  1523,  1525,
    1533,  1535,  1537,  1539,  1541,  1543,  1545,  1547,  1549,  1551,
    1553,  1555,  1557,  1559,  1561,  1563,  1565,  1567,  1569,  1571,
    1573,  1575,  1595,  1594,  1611,  1619,  1627,  1633,  1639,  1645,
    1650,  1655,  1663,  1671,  1679,  1687,  1695,  1703,  1711,  1719,
    1725,  1732,  1742,  1749,  1758,  1768,  1776,  1782,  1787,  1794,
    1798,  1820,  1823,  1827,  1830,  1833,  1838,  1841,  1849,  1855,
    1872,  1900,  1905,  1938,  1959,  1961,  1969,  1991,  1991,  1996,
    1996,  1996,  2001,  2001,  2006,  2044,  2058,  2061,  2064,  2067,
    2070,  2073,  2087
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_ADD",
  "TOK_ADD_TO", "TOK_ADDR", "TOK_ANY", "TOK_ATENDIF", "TOK_ATELSE",
  "TOK_ATIF", "TOK_ATIFDEF", "TOK_ATIFNDEF", "TOK_BOOL", "TOK_BREAK",
  "TOK_CASE", "TOK_OPTION", "TOK_CONST", "TOK_CONSTANT", "TOK_COPY",
  "TOK_COUNT", "TOK_DEFAULT", "TOK_DELETE", "TOK_DOUBLE", "TOK_ELSE",
  "TOK_ENUM", "TOK_EVENT", "TOK_EXPORT", "TOK_FALLTHROUGH", "TOK_FILE",
  "TOK_FOR", "TOK_FUNCTION", "TOK_GLOBAL", "TOK_HOOK", "TOK_ID", "TOK_IF",
  "TOK_INT", "TOK_INTERVAL", "TOK_LIST", "TOK_LOCAL", "TOK_MODULE",
  "TOK_NEXT", "TOK_OF", "TOK_OPAQUE", "TOK_PATTERN", "TOK_PATTERN_END",
  "TOK_PATTERN_TEXT", "TOK_PORT", "TOK_PRINT", "TOK_RECORD", "TOK_REDEF",
  "TOK_REMOVE_FROM", "TOK_RETURN", "TOK_SCHEDULE", "TOK_SET", "TOK_STRING",
  "TOK_SUBNET", "TOK_SWITCH", "TOK_TABLE", "TOK_TIME", "TOK_TIMEOUT",
  "TOK_TIMER", "TOK_TYPE", "TOK_UNION", "TOK_VECTOR", "TOK_WHEN",
  "TOK_WHILE", "TOK_AS", "TOK_IS", "TOK_ATTR_ADD_FUNC", "TOK_ATTR_DEFAULT",
  "TOK_ATTR_OPTIONAL", "TOK_ATTR_REDEF", "TOK_ATTR_DEL_FUNC",
  "TOK_ATTR_EXPIRE_FUNC", "TOK_ATTR_EXPIRE_CREATE", "TOK_ATTR_EXPIRE_READ",
  "TOK_ATTR_EXPIRE_WRITE", "TOK_ATTR_RAW_OUTPUT", "TOK_ATTR_ON_CHANGE",
  "TOK_ATTR_BROKER_STORE", "TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX",
  "TOK_ATTR_BACKEND", "TOK_ATTR_PRIORITY", "TOK_ATTR_LOG",
  "TOK_ATTR_ERROR_HANDLER", "TOK_ATTR_TYPE_COLUMN", "TOK_ATTR_DEPRECATED",
  "TOK_ATTR_IS_ASSIGNED", "TOK_ATTR_IS_USED", "TOK_DEBUG", "TOK_NO_TEST",
  "','", "'='", "'?'", "':'", "TOK_OR_OR", "TOK_AND_AND", "'<'", "'>'",
  "TOK_LE", "TOK_GE", "TOK_EQ", "TOK_NE", "TOK_IN", "TOK_NOT_IN", "'|'",
  "'^'", "'&'", "'+'", "'-'", "'*'", "'/'", "'%'", "TOK_INCR", "TOK_DECR",
  "'!'", "'~'", "'$'", "'['", "']'", "'('", "')'", "TOK_HAS_FIELD",
  "TOK_HAS_ATTR", "'{'", "'}'", "';'", "$accept", "zeek", "$@1",
  "decl_list", "opt_expr", "when_condition", "$@2", "$@3", "expr", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "expr_list", "opt_expr_list",
  "enum_body", "enum_body_list", "enum_body_elem", "type", "$@11", "$@12",
  "$@13", "type_list", "type_decl_list", "type_decl", "formal_args",
  "formal_args_decl_list", "formal_args_decl", "decl", "$@14", "$@15",
  "$@16", "$@17", "$@18", "$@19", "$@20", "conditional_list",
  "conditional", "func_hdr", "func_body", "$@21", "$@22", "lambda_body",
  "$@23", "$@24", "anonymous_function", "begin_lambda", "opt_captures",
  "capture_list", "capture", "opt_deep", "func_params", "opt_type",
  "init_class", "opt_init", "$@25", "$@26", "init", "index_slice",
  "opt_attr", "attr_list", "attr", "stmt", "$@27", "stmt_list", "event",
  "case_list", "case", "case_type_list", "case_type", "for_head",
  "local_id_list", "local_id", "global_id", "$@28", "def_global_id",
  "$@29", "$@30", "event_id", "$@31", "global_or_event_id", "resolve_id",
  "opt_no_test", "opt_no_test_block", "opt_deprecated", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,    44,    61,    63,    58,   346,   347,    60,    62,   348,
     349,   350,   351,   352,   353,   124,    94,    38,    43,    45,
      42,    47,    37,   354,   355,    33,   126,    36,    91,    93,
      40,    41,   356,   357,   123,   125,    59
};
#endif

#define YYPACT_NINF (-663)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-182)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -63,  -663,    94,  2484,  2570,  -663,  -663,  -663,   -89,   -22,
      17,  -663,  -663,  -663,    21,  -663,  -663,  -663,   108,   242,
    -663,  -663,  -663,  -663,  1003,  -663,    50,    57,  -663,  -663,
     147,    74,  2570,    87,    88,    91,  2570,  2570,  2570,  -663,
    2570,  2570,  2570,  2570,   164,  2449,  2570,  2197,  -663,  -663,
    2570,   172,   185,   127,  -663,   127,   104,   195,  -663,   104,
     127,   104,   110,  -663,  -663,  -663,   127,   195,   149,  -663,
    2570,   115,   147,  2570,   213,   122,   133,   137,   147,   132,
    2570,  2421,  2570,   148,   150,  -663,  -663,   739,  -663,   177,
    -663,  1003,  2570,   254,   151,   104,  2570,  -663,   182,  2570,
    1173,  2570,  -663,  2570,  2261,    92,    92,   232,    92,    92,
      92,    92,    -7,  -663,  2197,   -76,  1429,  2570,  2570,  2718,
    2718,  2570,  2602,  2570,  2570,  2570,  2570,  2570,  2570,  2570,
    2570,  2570,  2570,  2570,  2570,  2570,  2570,  2570,  2570,  2570,
    2570,   245,  2602,  -663,   251,  1493,   165,   166,  2718,     8,
    -663,     8,   261,  1622,  -663,  -663,  -663,  1622,     8,  1622,
    -663,   294,   104,  -663,     8,  -663,  -663,    96,   859,   209,
     127,   979,   180,   176,   209,   -10,  2570,    85,   209,   -70,
     186,   209,  1043,  1237,  -663,  2570,   217,   209,  2570,  -663,
    1557,  -663,   -36,  -663,   275,  -663,  -663,  -663,  2917,  2570,
     -39,   213,   218,   191,  2570,   197,   437,   272,  2570,   227,
    2570,  -663,  -663,  2197,  2197,  -663,  -663,  -663,  -663,  -663,
     196,   202,   282,   104,   205,  -663,  -663,  -663,   288,   289,
    -663,  -663,   214,   219,  -663,  -663,   222,  -663,  -663,   226,
     307,  -663,  -663,  -663,  2197,  1621,  2843,  2917,  2943,  2943,
    2943,  2943,  2943,  2943,    81,    81,  1446,    43,   416,   171,
     171,    92,    92,    92,  -663,   257,  1685,   -29,  2570,  -663,
    -663,  -663,  -663,  -663,  -663,  -663,  -663,  1238,  -663,  1238,
     258,   233,   -66,  -663,   263,   264,  -663,  -663,   266,   267,
     268,   271,   273,  -663,   279,   283,  -663,   284,   285,  -663,
    -663,   286,   299,  -663,  -663,  -663,  1622,  -663,   224,  -663,
    1238,  -663,   240,  1622,   363,  1238,  2718,  -663,  -663,  -663,
     209,  -663,  -663,     8,   209,  2570,   209,  -663,   -12,   147,
    1749,     8,  -663,   209,  -663,  -663,   209,  -663,   249,  2570,
    1813,  -663,  -663,  -663,  1109,  -663,   254,  -663,  -663,  -663,
    2197,  -663,   269,  1622,   253,  -663,  -663,  2197,  -663,  2197,
    -663,   261,  2718,  -663,   261,  2718,   359,  -663,  2718,  2718,
    2718,  2718,  2570,  2570,  -663,  -663,  1622,  1140,  1622,  2718,
     310,   261,   261,  2570,  2570,  2570,  2570,  2570,  2570,  2570,
    2570,  2570,  2570,  2570,  2570,   389,  -663,  -663,  1622,  -663,
    -663,   291,  1622,  1622,  -663,  -663,  1238,  -663,   287,  -663,
     376,  2570,    52,  -663,  1003,  1238,  -663,   292,  -663,    31,
    1003,  2197,  1003,   643,   209,  -663,  1003,  -663,  -663,  -663,
     151,   377,   298,  -663,   311,  -663,  -663,  -663,  -663,    55,
      66,   -64,  -663,  2749,   293,  2197,   312,   302,  2570,  2197,
    -663,   304,  1622,  2718,  -663,  -663,  2197,  2197,  2197,  2197,
    2197,  2197,  2197,  2197,  2197,  2197,  2197,  2197,  -663,   313,
     377,  -663,   317,   319,  1003,  1622,  -663,   332,  1877,   147,
      -2,   413,  1622,  1003,  2553,   343,  -663,  -663,   379,  -663,
    -663,  -663,  -663,   321,  1622,  -663,    -5,   324,   360,  -663,
    -663,  -663,   417,  2718,  -663,   415,  -663,  -663,  -663,  -663,
     367,   334,  -663,  -663,  -663,  -663,  -663,   338,  -663,  -663,
    -663,   339,   340,  2570,  -663,  -663,   432,  2570,  1003,   342,
     414,  2777,     2,    73,  -663,  -663,  2570,  -663,  -663,   380,
       7,  -663,  -663,   377,   382,   349,  -663,  -663,  2718,   309,
    -663,   351,   417,  -663,   209,  1941,   375,  2005,  -663,   209,
    2570,   418,  -663,   420,  -663,  1003,  1301,   462,   400,   470,
    -663,  2718,  -663,  -663,  -663,  -663,   366,  -663,  -663,  2570,
    -663,  -663,  1365,   455,  1003,  -663,  1003,   217,  -663,  -663,
    -663,  1622,  1622,  2069,   217,  -663,  -663,   369,   370,  -663,
    -663,   763,  -663,  -663,   883,  -663,  -663,  -663,   147,   372,
     373,  2602,  2602,  2602,  2602,  2602,  2602,   464,  2602,  2602,
    2777,  2777,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,
    2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,
    2602,  2602,  2325,   457,   388,   458,   391,   469,  2602,  2602,
     421,  2570,  -663,   278,   278,   278,   278,   278,   278,    -6,
    2325,  2325,  2325,  2133,  2870,  2990,  3016,  3016,  3016,  3016,
    3016,  3016,  2586,  2586,  1510,   394,  1318,   193,   193,   278,
     278,   278,  2777,   261,  2777,  2718,  2777,  2325,  2990,  2602,
     396,  2570,  2602,  2602,   397,    77,  2325,  1686,   401,  2325,
    2796,  -663,   474,   438,   439,   443,   445,   447,   449,   450,
     451,   454,   456,   463,   465,  1686,  -663,  2777,  2602,  2602,
    2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,  2602,
    1686,  2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,  2325,
    2325,  2325,  2325
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       6,     3,     0,   239,     0,     1,   149,   150,     0,     0,
       0,   259,   259,   262,     0,   259,   259,   259,     0,   257,
     257,     5,   143,   141,     2,    66,     0,   164,    60,    65,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    67,
       0,     0,     0,     0,     0,     0,     0,     4,    63,    42,
       0,     0,     0,   173,   257,   173,     0,     0,   127,     0,
     173,     0,     0,   257,   262,   257,   173,     0,     0,   144,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   212,   236,     0,   237,    42,
     238,     0,     0,   169,     0,     0,     0,   256,     0,     0,
       0,    75,    52,    75,     0,    19,    18,     0,    14,    15,
      16,    17,   164,    50,    73,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     8,    57,     0,     0,     0,     0,     0,   174,
     260,   174,   121,   187,   264,   263,     6,   187,   174,   187,
     126,     0,     0,   135,   174,   258,   139,     0,     0,   267,
     173,     0,     0,     0,   267,     0,     0,   173,   267,     0,
       0,   267,     0,     0,     9,     0,   269,   267,     0,   219,
       0,   168,     0,   166,     0,   158,   161,   162,    61,     0,
       0,     0,    74,     0,    75,     0,    69,     0,     0,     0,
       0,    49,    12,    21,    23,    93,    95,    83,    85,    86,
       0,     0,   111,     0,     0,   265,    84,    88,   104,     0,
      90,    92,     0,     0,    89,    94,     0,    87,    91,     0,
       0,    70,   113,    71,    39,     0,    31,    30,    34,    36,
      35,    37,    32,    33,    47,    48,    28,    29,    27,    20,
      22,    24,    25,    26,    43,     0,    73,     0,    75,    62,
     146,   147,   148,   172,   176,   177,   175,   178,   261,   178,
       0,     0,   119,   124,     0,     0,   191,   192,     0,     0,
       0,     0,     0,   205,     0,     0,   199,     0,     0,   208,
     209,     0,   210,   193,   194,   152,   186,   189,     0,   151,
     178,   153,     0,   187,     0,   178,     0,   155,   145,   142,
     267,   266,   222,   174,   267,    75,   267,   223,     0,     0,
       0,   174,   221,   267,     9,   224,   267,   242,     0,     0,
       0,   268,   239,   235,     0,    13,   169,   163,   167,   239,
      40,    51,     0,   187,     0,    56,    68,    44,    45,    72,
     102,   121,     0,   107,   121,     0,     0,    98,     0,     0,
       0,     0,     0,     8,    41,    58,   187,     0,   187,     0,
     171,     0,   120,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   188,   128,   187,   133,
     154,     0,   187,   187,   239,   226,   178,   227,     0,   215,
       0,     0,     0,   255,     0,   178,   214,     0,   225,     0,
       0,    10,     0,     0,   267,   165,   159,    64,    55,    53,
       0,     0,     0,   110,     0,   105,   112,   117,   115,     0,
       0,     0,   106,    38,     0,     7,     0,     0,    75,   184,
     179,     0,   187,     0,   123,   122,   195,   190,   196,   201,
     202,   203,   204,   197,   198,   200,   206,   207,   211,     0,
       0,   136,     0,     0,   156,   187,   240,     0,     0,     0,
       0,   216,   187,     0,     0,     0,   218,   241,   230,    11,
     220,   213,   234,     0,   187,    46,   272,     0,    76,    78,
     108,   109,    99,     0,    97,     0,   101,   185,    59,   130,
      74,     0,   180,   131,   125,   170,   129,     0,   117,   132,
     140,     0,     0,     0,   250,   254,     0,     0,     0,     0,
     232,     0,     0,     0,   247,   239,     0,   160,    54,   270,
       0,    82,   103,    77,     0,     0,   116,   114,     0,     0,
     182,     0,   137,   157,   267,     0,     0,     0,   217,   267,
       0,   248,   239,     0,   239,   245,     0,     0,   272,     0,
      79,     0,   100,    96,   183,   134,     0,   229,   252,     0,
     251,   228,     0,     0,   243,   246,   244,   269,   271,    80,
      81,   187,   187,     0,   269,   249,   239,     0,     0,   253,
     239,     0,   118,   138,     0,   231,   233,    60,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    73,   111,     0,   104,     0,     0,     0,     0,
       0,    75,    52,    19,    18,    14,    15,    16,    17,   164,
      21,    23,    39,     0,    31,    30,    34,    36,    35,    37,
      32,    33,    47,    48,    28,    29,    27,    20,    22,    24,
      25,    26,     0,   121,     0,     0,     0,    72,    61,     0,
       0,    75,     0,     0,     0,     0,    40,   187,     0,    44,
      38,   171,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   186,    53,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     187,   195,   190,   196,   201,   202,   203,   204,   197,   198,
     200,   206,   207
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -663,  -663,  -663,   398,   156,   225,  -663,  -663,    -4,  -663,
    -105,  -158,  -663,  -663,   -47,  -663,   -27,  -102,    97,  -663,
      18,  -100,  -663,  -663,  -663,  -353,    44,  -663,  -350,  -663,
    -199,  -663,  -663,  -663,  -663,  -663,  -663,  -663,  -663,  -663,
       6,  -663,  -663,  -663,  -663,   134,  -663,  -663,  -663,   539,
    -663,  -663,   223,  -663,    83,    -1,  -101,  -266,  -663,  -663,
    -663,   -21,  -151,  -662,  -299,   -86,  -663,  -320,   371,  -663,
    -663,  -663,     5,  -663,  -663,   -68,    10,  -663,   280,  -663,
    -663,   506,  -663,   504,  -663,  -107,  -547,     9
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,   265,   338,   339,   489,    87,   430,
     204,   494,   268,   446,    96,   107,   202,   203,   497,   498,
     499,   438,   437,   545,   431,   439,   502,   546,   281,   282,
     283,    21,   156,   470,   314,   518,   576,   316,    69,   167,
      88,    23,   319,   404,   521,   196,   349,   493,    48,   209,
      95,   192,   193,   194,   363,   149,   277,   376,   377,   512,
     450,    49,   428,   306,   307,    90,   186,    24,   173,   419,
     487,   533,   534,    91,   412,    98,    66,    67,    53,    54,
     278,    56,    57,   155,   242,   322,   342,   541
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      47,   205,   305,    89,   170,   189,   309,   396,   311,    22,
     177,   432,   274,   378,   434,   210,   440,   441,   115,   241,
     243,   210,   423,   328,   568,   381,     1,   503,   100,   426,
      68,    50,   104,   105,   106,   715,   108,   109,   110,   111,
     596,   114,   116,   211,   398,   484,   145,   600,   273,   402,
     279,   485,   210,   179,   151,   346,   333,   310,   275,   158,
     382,   506,   210,   315,   150,   164,   168,   327,   715,   171,
      89,   332,   200,   161,   335,   163,   114,   182,   183,   410,
     343,   539,   351,   347,   474,   208,   692,   540,   190,   526,
     374,   411,   198,   648,     5,   114,   562,   114,    51,   114,
     276,   527,   354,     6,     7,     8,     9,    10,   329,   119,
     120,    93,    93,   213,   214,   267,   569,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,   261,   262,   263,    52,   266,   153,
     475,    62,   157,   479,   159,    58,   503,   119,   120,   482,
     135,   136,   137,   138,   139,   140,   486,   503,   119,   120,
     141,   142,   400,   143,   563,   144,   375,   564,   503,   323,
      92,   480,   330,   318,   504,    93,   331,   199,   197,   148,
      97,   340,   454,   455,   344,   505,   133,   134,   135,   136,
     137,   138,   139,   140,    99,   350,   702,   112,   141,   142,
     114,   143,   256,   144,   357,   146,   359,   101,   102,   141,
     142,   103,   143,   405,   144,   565,   403,   407,   147,   409,
     317,   148,   406,   408,   152,   447,   416,   451,   154,   418,
     415,     6,     7,     8,     9,    10,   160,   119,   120,    11,
      12,   169,   584,   166,   586,   313,   172,   469,   174,    13,
      14,   472,   473,   175,    15,    16,    17,   176,   178,   620,
     621,   413,   433,    18,   114,   435,    63,    64,   184,   188,
     185,   442,   191,    19,   199,   195,   601,   207,   264,   452,
     604,   138,   139,   140,   269,    20,   271,   272,   141,   142,
      65,   143,    55,   144,   280,    59,    60,    61,   312,   321,
     325,   514,   326,   639,   640,   641,   334,   341,   348,   210,
     141,   142,   353,   143,    22,   144,   356,   492,   355,   358,
     360,   114,   361,   362,   522,   364,    25,    26,   481,   365,
     366,   529,   695,   694,   488,   421,   490,   368,   367,    27,
     369,    28,    29,   538,   620,   621,   511,    30,   371,   397,
     370,   373,   379,   515,   380,   383,   384,    31,   385,   386,
     387,    32,    33,   388,   399,   389,    34,   401,   443,   445,
     420,   390,    35,   449,   429,   391,   392,   393,   394,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   395,   436,    89,   427,   141,   142,   530,   143,    89,
     144,    89,    89,   547,   453,    89,   468,   478,   476,   477,
     496,   525,   507,   483,    36,   471,   396,    37,    38,   500,
      39,   510,    40,    41,    42,    43,    44,    45,   509,    46,
     513,   561,   501,   508,   574,   523,   528,   535,   536,   516,
     597,   598,   558,   519,   114,   520,   537,   577,   573,   542,
     544,   543,   581,    89,    25,    26,   548,   532,   549,   550,
     620,   621,    89,   551,   553,   556,   554,    27,   559,    28,
      29,   591,   567,   560,   572,    30,   571,   575,   579,   588,
     642,   531,   119,   120,   583,    31,   539,   590,   595,    32,
      33,   592,   651,   652,    34,   602,   603,   659,   682,   684,
      35,   636,   637,   638,   639,   640,   641,    89,   683,   685,
     686,   141,   142,   689,   143,   717,   144,   697,   701,   555,
     241,   243,   716,   557,   136,   137,   138,   139,   140,   444,
     718,   719,   566,   141,   142,   720,   143,   721,   144,   722,
     650,   723,   724,   725,    89,   359,   726,   691,   727,   690,
      40,    41,    42,    43,   308,   728,   582,   729,   730,   417,
     649,   570,   552,    89,   495,    89,    94,   517,   585,   425,
     162,   165,   352,     0,     0,   593,     0,   589,     0,   538,
      89,     0,   433,    89,   435,     0,   442,     0,     0,   698,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   653,   654,   655,
     656,   657,   658,     0,   660,   661,     0,   573,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,     0,     0,
       0,     0,     0,     0,   687,   688,    70,   114,     0,     0,
       6,     7,     8,     9,    10,     0,    71,     0,     0,    72,
      25,    26,     0,     0,    73,     0,     0,     0,    74,     0,
      75,     0,    76,    27,     0,    28,    29,    77,     0,     0,
       0,    78,     0,    79,     0,   696,     0,   114,   699,   700,
      80,    31,     0,     0,    81,    32,    33,     0,     0,    82,
      34,     0,     0,     0,     0,     0,    35,    83,    84,     0,
       0,     0,     0,     0,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   117,     0,     0,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,    70,    85,   491,    86,
       6,     7,     8,     9,    10,     0,    71,     0,     0,    72,
      25,    26,     0,     0,    73,     0,     0,     0,    74,   118,
      75,     0,    76,    27,     0,    28,    29,    77,     0,     0,
       0,    78,     0,    79,     0,   119,   120,     0,     0,     0,
      80,    31,     0,     0,    81,    32,    33,     0,     0,    82,
      34,     0,     0,     0,     0,     0,    35,    83,    84,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,     0,   141,   142,     0,   143,
       0,   144,     0,   117,     0,   187,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,    70,    85,   605,    86,
       6,     7,     8,     9,    10,     0,    71,     0,     0,    72,
      25,    26,     0,     0,    73,     0,     0,     0,    74,   118,
      75,     0,    76,    27,     0,    28,    29,    77,     0,     0,
       0,    78,     0,    79,     0,   119,   120,     0,     0,     0,
      80,    31,     0,     0,    81,    32,    33,     0,     0,    82,
      34,     0,     0,     0,     0,     0,    35,    83,    84,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,     0,     0,     0,   141,   142,     0,   143,
       0,   144,     0,   117,     0,   320,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,    70,    85,   606,    86,
       6,     7,     8,     9,    10,     0,    71,     0,     0,    72,
      25,    26,     0,     0,    73,     0,     0,     0,    74,   118,
      75,     0,    76,    27,     0,    28,    29,    77,     0,     0,
       0,    78,     0,    79,     0,   119,   120,   117,     0,     0,
      80,    31,     0,     0,    81,    32,    33,     0,     0,    82,
      34,     0,     0,     0,     0,     0,    35,    83,    84,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   118,     0,     0,   141,   142,     0,   143,
       0,   144,     0,     0,     0,   324,     0,     0,    36,   119,
     120,    37,    38,   117,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,     0,    85,     0,    86,
       0,     0,     0,     0,     0,   121,   122,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,    25,    26,   118,
     141,   142,     0,   143,     0,   144,     0,     0,     0,   336,
      27,     0,    28,    29,     0,   119,   120,   117,    30,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    31,     0,
       0,     0,    32,    33,     0,     0,     0,    34,     0,     0,
       0,   121,   122,    35,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   118,     0,     0,   141,   142,     0,   143,
       0,   144,     0,     0,     0,   424,     0,     0,     0,   119,
     120,   117,     0,     0,     0,    36,     0,     0,    37,    38,
       0,    39,     0,    40,    41,    42,    43,    44,    45,     0,
      46,     0,     0,     0,   448,   121,   122,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,   118,     0,     0,
     141,   142,     0,   143,     0,   144,     0,   201,     0,     0,
       0,     0,     0,   119,   120,   117,  -181,  -181,  -181,  -181,
    -181,  -181,  -181,  -181,  -181,  -181,  -181,  -181,  -181,  -181,
    -181,  -181,  -181,  -181,  -181,  -181,  -181,     0,     0,   121,
     122,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   118,     0,     0,   141,   142,     0,   143,     0,   144,
       0,   337,     0,     0,  -181,     0,     0,   119,   120,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   620,   621,     0,     0,     0,     0,
       0,     0,     0,   121,   122,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,     0,   118,     0,     0,   141,   142,
       0,   143,     0,   144,     0,   587,   637,   638,   639,   640,
     641,   119,   120,   117,     0,   141,   142,     0,   143,     0,
     144,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   121,   122,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,     0,   118,
       0,     0,   141,   142,     0,   143,     0,   144,     0,   594,
       0,     0,     0,     0,     0,   119,   120,   117,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   119,   120,     0,     0,     0,     0,     0,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   118,     0,     0,   141,   142,     0,   143,
     212,   144,   134,   135,   136,   137,   138,   139,   140,   119,
     120,   117,     0,   141,   142,     0,   143,     0,   144,     0,
       0,     0,     0,     0,     0,     0,   620,   621,     0,     0,
       0,     0,     0,     0,     0,   121,   122,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,   118,     0,     0,
     141,   142,     0,   143,   270,   144,   635,   636,   637,   638,
     639,   640,   641,   119,   120,   618,     0,   141,   142,     0,
     143,     0,   144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   121,
     122,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   619,     0,     0,   141,   142,     0,   143,   345,   144,
       0,     0,     0,     0,     0,     0,     0,   620,   621,   618,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,     0,     0,   622,   623,   372,   624,   625,   626,   627,
     628,   629,   630,   631,   632,   633,   634,   635,   636,   637,
     638,   639,   640,   641,     0,   619,     0,     0,   141,   142,
       0,   143,     0,   144,     0,     0,     0,     0,     0,     0,
       0,   620,   621,   117,   703,   704,   286,   287,   705,   706,
     707,   708,   709,   293,   710,   711,   296,   712,   713,   299,
     300,   714,   302,   303,   304,     0,     0,   622,   623,    -7,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,     0,   118,
       0,     0,   141,   142,     0,   143,     0,   144,     0,     0,
       0,     0,     0,     0,     0,   119,   120,   117,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   118,     0,     0,   141,   142,     0,   143,
     414,   144,     0,     0,     0,     0,     0,     0,     0,   119,
     120,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   121,   122,     0,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,   118,     0,     0,
     141,   142,     0,   143,   422,   144,     0,     0,     0,     0,
       0,     0,     0,   119,   120,   117,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   121,
     122,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   118,     0,     0,   141,   142,     0,   143,   524,   144,
       0,     0,     0,     0,     0,     0,     0,   119,   120,   117,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   121,   122,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,     0,   118,     0,     0,   141,   142,
       0,   143,   578,   144,     0,     0,     0,     0,     0,     0,
       0,   119,   120,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   121,   122,     0,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,     0,   118,
       0,     0,   141,   142,     0,   143,   580,   144,     0,     0,
       0,     0,     0,     0,     0,   119,   120,   618,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   121,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,     0,   619,     0,     0,   141,   142,     0,   143,
     599,   144,     0,     0,     0,     0,     0,     0,     0,   620,
     621,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   622,   623,   693,   624,   625,
     626,   627,   628,   629,   630,   631,   632,   633,   634,   635,
     636,   637,   638,   639,   640,   641,     0,   118,     0,     0,
     141,   142,     0,   143,     0,   144,     0,     0,     0,     0,
       0,     0,     0,   119,   120,   117,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   121,
     122,     0,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,   118,     0,     0,   141,   142,     0,   143,     0,   144,
       0,     0,     0,     0,     0,     0,     0,   119,   120,   618,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   121,   122,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   206,   134,   135,   136,
     137,   138,   139,   140,     0,   619,     0,     0,   141,   142,
       0,   143,     0,   144,     0,     0,     0,     0,     0,     0,
       0,   620,   621,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   622,   623,     0,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,    25,    26,
       0,     0,   141,   142,     0,   143,     0,   144,     0,     0,
       0,    27,     0,    28,    29,     0,     0,     0,     0,    30,
       0,     0,     0,     0,     0,     0,    25,    26,     0,    31,
       0,     0,     0,    32,    33,     0,     0,     0,    34,    27,
       0,    28,    29,     0,    35,   180,     0,    30,     0,     0,
       0,     6,     7,     8,     9,    10,     0,    31,     0,    11,
      12,    32,    33,     0,     0,     0,    34,     0,     0,    13,
      14,     0,    35,     0,    15,    16,    17,     0,     0,     0,
       0,     0,     0,    18,     0,     0,    36,     0,     0,    37,
      38,     0,    39,    19,    40,    41,    42,    43,    44,    45,
       0,    46,     0,     0,     0,    20,     0,   181,     0,     0,
       0,     0,     0,     0,    36,     0,     0,    37,    38,     0,
      39,     0,    40,    41,    42,    43,    44,    45,   113,    46,
      25,    26,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,     0,   607,    29,    25,    26,     0,
       0,   608,     0,     0,     0,     0,     0,     0,     0,     0,
      27,    31,    28,    29,     0,    32,   609,     0,    30,     0,
     610,     0,     0,     0,   531,     0,    35,     0,    31,    25,
      26,     0,    32,    33,     0,     0,     0,    34,     0,     0,
       0,     0,    27,    35,   607,    29,     0,     0,     0,     0,
     608,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      31,     0,   620,   621,    32,   609,     0,     0,    36,   610,
       0,   611,   612,     0,    39,    35,   613,   614,   615,   616,
     617,    45,     0,    46,     0,    36,     0,     0,    37,    38,
       0,    39,     0,    40,    41,    42,    43,    44,    45,     0,
      46,   634,   635,   636,   637,   638,   639,   640,   641,     0,
       0,     0,     0,   141,   142,     0,   143,    36,   144,     0,
     611,   612,     0,    39,     0,   613,   614,   615,   616,   617,
      45,     0,    46,   215,   216,     0,     0,     0,     0,     0,
     217,     0,     0,     0,     0,     0,     0,   218,     0,     0,
     219,     0,   220,   221,     0,     0,   222,     0,   223,     0,
     224,   225,     0,   226,   227,   228,     0,     0,     0,     0,
     229,   230,     0,     0,   231,     0,   232,     0,     0,     0,
       0,   233,   234,   235,     0,   236,   237,     0,   238,     0,
     239,   240,   215,   216,     0,     0,     0,     0,     0,   217,
       0,     0,     0,     0,     0,     0,   218,     0,     0,   219,
       0,   220,   221,     0,     0,   643,     0,   644,     0,   224,
     225,     0,   226,   227,   645,   119,   120,     0,     0,   229,
     230,     0,     0,   231,     0,   232,     0,     0,     0,     0,
     233,   234,   235,     0,   646,   237,     0,   238,     0,   239,
     647,     0,   122,     0,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   620,   621,     0,     0,   141,   142,     0,   143,
       0,   144,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   623,
       0,   624,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,   119,
     120,     0,     0,   141,   142,     0,   143,     0,   144,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   620,   621,     0,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,     0,     0,     0,     0,
     141,   142,     0,   143,     0,   144,   625,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,   119,   120,     0,     0,   141,   142,     0,
     143,     0,   144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   119,
     120,     0,     0,     0,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
       0,     0,     0,     0,   141,   142,     0,   143,     0,   144,
    -182,  -182,  -182,  -182,  -182,  -182,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   620,   621,     0,     0,
     141,   142,     0,   143,     0,   144,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   620,   621,     0,     0,     0,   626,   627,   628,
     629,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     639,   640,   641,     0,     0,     0,     0,   141,   142,     0,
     143,     0,   144,  -182,  -182,  -182,  -182,  -182,  -182,   632,
     633,   634,   635,   636,   637,   638,   639,   640,   641,     0,
       0,     0,     0,   141,   142,     0,   143,     0,   144
};

static const yytype_int16 yycheck[] =
{
       4,   103,   153,    24,    72,    91,   157,   306,   159,     3,
      78,   361,     4,   279,   364,    91,   369,   370,    45,   119,
     120,    91,   342,    33,    17,    91,    89,    91,    32,   349,
      20,   120,    36,    37,    38,   697,    40,    41,    42,    43,
     587,    45,    46,   119,   310,    14,    50,   594,   148,   315,
     151,    20,    91,    80,    55,    91,   126,   158,    50,    60,
     126,   125,    91,   164,    54,    66,    70,   174,   730,    73,
      91,   178,    99,    63,   181,    65,    80,    81,    82,    91,
     187,    86,   121,   119,   404,    92,    92,    92,    92,    91,
     119,   103,    96,    91,     0,    99,    94,   101,   120,   103,
      92,   103,   204,     7,     8,     9,    10,    11,   118,    66,
      67,   118,   118,   117,   118,   142,   109,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   120,   142,    56,
     406,    33,    59,    91,    61,   124,    91,    66,    67,   415,
     107,   108,   109,   110,   111,   112,   125,    91,    66,    67,
     117,   118,   313,   120,    91,   122,   268,    94,    91,   170,
     120,   119,   176,   167,   119,   118,   177,    92,    95,    94,
      33,   185,   381,   382,   188,   119,   105,   106,   107,   108,
     109,   110,   111,   112,   120,   199,   119,    33,   117,   118,
     204,   120,   206,   122,   208,    33,   210,   120,   120,   117,
     118,   120,   120,   320,   122,   535,   316,   324,    33,   326,
     124,    94,   323,   325,   120,   376,   333,   378,    33,   336,
     331,     7,     8,     9,    10,    11,   126,    66,    67,    15,
      16,   126,   562,    94,   564,   162,    33,   398,   126,    25,
      26,   402,   403,   120,    30,    31,    32,   120,   126,    66,
      67,   329,   362,    39,   268,   365,    24,    25,   120,    92,
     120,   371,    18,    49,    92,   124,   596,    45,    33,   379,
     600,   110,   111,   112,    33,    61,   121,   121,   117,   118,
      48,   120,    12,   122,    33,    15,    16,    17,     4,    90,
     120,   452,   126,   110,   111,   112,   120,    90,    33,    91,
     117,   118,   121,   120,   308,   122,    44,   424,   121,    92,
     124,   325,   120,    41,   475,   120,    17,    18,   414,    41,
      41,   482,   685,   683,   420,   339,   422,   118,   124,    30,
     118,    32,    33,   494,    66,    67,   448,    38,    41,   125,
     124,    94,    94,   453,   121,    92,    92,    48,    92,    92,
      92,    52,    53,    92,   124,    92,    57,     4,   372,   373,
     121,    92,    63,   377,   121,    92,    92,    92,    92,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,    92,    33,   414,   125,   117,   118,   483,   120,   420,
     122,   422,   423,   503,    94,   426,    17,   411,   121,    33,
      33,   479,   119,   121,   105,   124,   715,   108,   109,   121,
     111,   448,   113,   114,   115,   116,   117,   118,   126,   120,
     126,   531,   121,   121,   125,   103,    23,    94,    59,   126,
     591,   592,   528,   126,   448,   126,   125,   554,   548,   125,
      33,    91,   559,   474,    17,    18,    41,   484,    91,   125,
      66,    67,   483,   125,   125,    33,   126,    30,   126,    32,
      33,   571,    92,    59,   125,    38,    94,   126,   103,    17,
     484,    61,    66,    67,    66,    48,    86,    17,    33,    52,
      53,   125,   120,   120,    57,   126,   126,    33,    41,    41,
      63,   107,   108,   109,   110,   111,   112,   528,   120,   118,
      41,   117,   118,    92,   120,    41,   122,   121,   121,   523,
     620,   621,   121,   527,   108,   109,   110,   111,   112,   373,
      92,    92,   536,   117,   118,    92,   120,    92,   122,    92,
     608,    92,    92,    92,   565,   549,    92,   652,    92,   651,
     113,   114,   115,   116,   156,    92,   560,    92,   716,   334,
     607,   543,   518,   584,   430,   586,    27,   470,   563,   346,
      64,    67,   201,    -1,    -1,   579,    -1,   568,    -1,   730,
     601,    -1,   682,   604,   684,    -1,   686,    -1,    -1,   691,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   611,   612,   613,
     614,   615,   616,    -1,   618,   619,    -1,   717,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,    -1,    -1,
      -1,    -1,    -1,    -1,   648,   649,     3,   651,    -1,    -1,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    21,    -1,    -1,    -1,    25,    -1,
      27,    -1,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,   689,    -1,   691,   692,   693,
      47,    48,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    -1,    -1,    -1,   718,   719,   720,   721,   722,   723,
     724,   725,   726,   727,   728,   729,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     4,    -1,    -1,    -1,    -1,   105,    -1,
      -1,   108,   109,    -1,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,    -1,     3,   124,   125,   126,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    21,    -1,    -1,    -1,    25,    50,
      27,    -1,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,    66,    67,    -1,    -1,    -1,
      47,    48,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    -1,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,     4,    -1,   126,    -1,    -1,   105,    -1,
      -1,   108,   109,    -1,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,    -1,     3,   124,   125,   126,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    21,    -1,    -1,    -1,    25,    50,
      27,    -1,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,    66,    67,    -1,    -1,    -1,
      47,    48,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    -1,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,     4,    -1,   126,    -1,    -1,   105,    -1,
      -1,   108,   109,    -1,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,    -1,     3,   124,   125,   126,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    21,    -1,    -1,    -1,    25,    50,
      27,    -1,    29,    30,    -1,    32,    33,    34,    -1,    -1,
      -1,    38,    -1,    40,    -1,    66,    67,     4,    -1,    -1,
      47,    48,    -1,    -1,    51,    52,    53,    -1,    -1,    56,
      57,    -1,    -1,    -1,    -1,    -1,    63,    64,    65,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,    -1,    -1,   126,    -1,    -1,   105,    66,
      67,   108,   109,     4,   111,    -1,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,    -1,    -1,   124,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    17,    18,    50,
     117,   118,    -1,   120,    -1,   122,    -1,    -1,    -1,   126,
      30,    -1,    32,    33,    -1,    66,    67,     4,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,
      -1,    -1,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    92,    93,    63,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,    -1,    -1,   126,    -1,    -1,    -1,    66,
      67,     4,    -1,    -1,    -1,   105,    -1,    -1,   108,   109,
      -1,   111,    -1,   113,   114,   115,   116,   117,   118,    -1,
     120,    -1,    -1,    -1,   124,    92,    93,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    50,    -1,    -1,
     117,   118,    -1,   120,    -1,   122,    -1,   124,    -1,    -1,
      -1,    -1,    -1,    66,    67,     4,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    -1,    -1,    92,
      93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    50,    -1,    -1,   117,   118,    -1,   120,    -1,   122,
      -1,   124,    -1,    -1,   126,    -1,    -1,    66,    67,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    66,    67,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    50,    -1,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,   124,   108,   109,   110,   111,
     112,    66,    67,     4,    -1,   117,   118,    -1,   120,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,    50,
      -1,    -1,   117,   118,    -1,   120,    -1,   122,    -1,   124,
      -1,    -1,    -1,    -1,    -1,    66,    67,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
     121,   122,   106,   107,   108,   109,   110,   111,   112,    66,
      67,     4,    -1,   117,   118,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    50,    -1,    -1,
     117,   118,    -1,   120,   121,   122,   106,   107,   108,   109,
     110,   111,   112,    66,    67,     4,    -1,   117,   118,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    50,    -1,    -1,   117,   118,    -1,   120,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,     4,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    50,    -1,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,     4,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    -1,    -1,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,    50,
      -1,    -1,   117,   118,    -1,   120,    -1,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    50,    -1,    -1,
     117,   118,    -1,   120,   121,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    50,    -1,    -1,   117,   118,    -1,   120,   121,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    50,    -1,    -1,   117,   118,
      -1,   120,   121,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,    50,
      -1,    -1,   117,   118,    -1,   120,   121,   122,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    67,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    92,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    -1,    50,    -1,    -1,   117,   118,    -1,   120,
     121,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,     4,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    50,    -1,    -1,
     117,   118,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    66,    67,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,
      93,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    50,    -1,    -1,   117,   118,    -1,   120,    -1,   122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,    -1,    50,    -1,    -1,   117,   118,
      -1,   120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    17,    18,
      -1,    -1,   117,   118,    -1,   120,    -1,   122,    -1,    -1,
      -1,    30,    -1,    32,    33,    -1,    -1,    -1,    -1,    38,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    -1,    48,
      -1,    -1,    -1,    52,    53,    -1,    -1,    -1,    57,    30,
      -1,    32,    33,    -1,    63,    64,    -1,    38,    -1,    -1,
      -1,     7,     8,     9,    10,    11,    -1,    48,    -1,    15,
      16,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,    25,
      26,    -1,    63,    -1,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    -1,    -1,   105,    -1,    -1,   108,
     109,    -1,   111,    49,   113,   114,   115,   116,   117,   118,
      -1,   120,    -1,    -1,    -1,    61,    -1,   126,    -1,    -1,
      -1,    -1,    -1,    -1,   105,    -1,    -1,   108,   109,    -1,
     111,    -1,   113,   114,   115,   116,   117,   118,   119,   120,
      17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    -1,    32,    33,    17,    18,    -1,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      30,    48,    32,    33,    -1,    52,    53,    -1,    38,    -1,
      57,    -1,    -1,    -1,    61,    -1,    63,    -1,    48,    17,
      18,    -1,    52,    53,    -1,    -1,    -1,    57,    -1,    -1,
      -1,    -1,    30,    63,    32,    33,    -1,    -1,    -1,    -1,
      38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    -1,    66,    67,    52,    53,    -1,    -1,   105,    57,
      -1,   108,   109,    -1,   111,    63,   113,   114,   115,   116,
     117,   118,    -1,   120,    -1,   105,    -1,    -1,   108,   109,
      -1,   111,    -1,   113,   114,   115,   116,   117,   118,    -1,
     120,   105,   106,   107,   108,   109,   110,   111,   112,    -1,
      -1,    -1,    -1,   117,   118,    -1,   120,   105,   122,    -1,
     108,   109,    -1,   111,    -1,   113,   114,   115,   116,   117,
     118,    -1,   120,     5,     6,    -1,    -1,    -1,    -1,    -1,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,
      22,    -1,    24,    25,    -1,    -1,    28,    -1,    30,    -1,
      32,    33,    -1,    35,    36,    37,    -1,    -1,    -1,    -1,
      42,    43,    -1,    -1,    46,    -1,    48,    -1,    -1,    -1,
      -1,    53,    54,    55,    -1,    57,    58,    -1,    60,    -1,
      62,    63,     5,     6,    -1,    -1,    -1,    -1,    -1,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    19,    -1,    -1,    22,
      -1,    24,    25,    -1,    -1,    28,    -1,    30,    -1,    32,
      33,    -1,    35,    36,    37,    66,    67,    -1,    -1,    42,
      43,    -1,    -1,    46,    -1,    48,    -1,    -1,    -1,    -1,
      53,    54,    55,    -1,    57,    58,    -1,    60,    -1,    62,
      63,    -1,    93,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,    66,    67,    -1,    -1,   117,   118,    -1,   120,
      -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,    66,
      67,    -1,    -1,   117,   118,    -1,   120,    -1,   122,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    -1,    -1,    -1,    -1,
     117,   118,    -1,   120,    -1,   122,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,    66,    67,    -1,    -1,   117,   118,    -1,
     120,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,
      67,    -1,    -1,    -1,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    -1,    -1,    -1,   117,   118,    -1,   120,    -1,   122,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,    66,    67,    -1,    -1,
     117,   118,    -1,   120,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,    -1,    -1,    -1,    -1,   117,   118,    -1,
     120,    -1,   122,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,    -1,
      -1,    -1,    -1,   117,   118,    -1,   120,    -1,   122
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    89,   128,   130,   129,     0,     7,     8,     9,    10,
      11,    15,    16,    25,    26,    30,    31,    32,    39,    49,
      61,   158,   167,   168,   194,    17,    18,    30,    32,    33,
      38,    48,    52,    53,    57,    63,   105,   108,   109,   111,
     113,   114,   115,   116,   117,   118,   120,   135,   175,   188,
     120,   120,   120,   205,   206,   205,   208,   209,   124,   205,
     205,   205,    33,    24,    25,    48,   203,   204,   203,   165,
       3,    13,    16,    21,    25,    27,    29,    34,    38,    40,
      47,    51,    56,    64,    65,   124,   126,   135,   167,   188,
     192,   200,   120,   118,   176,   177,   141,    33,   202,   120,
     135,   120,   120,   120,   135,   135,   135,   142,   135,   135,
     135,   135,    33,   119,   135,   143,   135,     4,    50,    66,
      67,    92,    93,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   117,   118,   120,   122,   135,    33,    33,    94,   182,
     203,   182,   120,   181,    33,   210,   159,   181,   182,   181,
     126,   203,   208,   203,   182,   210,    94,   166,   135,   126,
     202,   135,    33,   195,   126,   120,   120,   202,   126,   143,
      64,   126,   135,   135,   120,   120,   193,   126,    92,   192,
     135,    18,   178,   179,   180,   124,   172,   181,   135,    92,
     143,   124,   143,   144,   137,   144,   105,    45,    92,   176,
      91,   119,   121,   135,   135,     5,     6,    12,    19,    22,
      24,    25,    28,    30,    32,    33,    35,    36,    37,    42,
      43,    46,    48,    53,    54,    55,    57,    58,    60,    62,
      63,   148,   211,   148,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,    33,   131,   135,   143,   139,    33,
     121,   121,   121,   148,     4,    50,    92,   183,   207,   183,
      33,   155,   156,   157,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,   189,   190,   191,   130,   189,
     183,   189,     4,   181,   161,   183,   164,   124,   167,   169,
     126,    90,   212,   182,   126,   120,   126,   212,    33,   118,
     135,   182,   212,   126,   120,   212,   126,   124,   132,   133,
     135,    90,   213,   212,   135,   121,    91,   119,    33,   173,
     135,   121,   195,   121,   144,   121,    44,   135,    92,   135,
     124,   120,    41,   181,   120,    41,    41,   124,   118,   118,
     124,    41,    94,    94,   119,   144,   184,   185,   184,    94,
     121,    91,   126,    92,    92,    92,    92,    92,    92,    92,
      92,    92,    92,    92,    92,    92,   191,   125,   184,   124,
     189,     4,   184,   148,   170,   212,   183,   212,   144,   212,
      91,   103,   201,   202,   121,   183,   212,   132,   212,   196,
     121,   135,   121,   194,   126,   179,   194,   125,   189,   121,
     136,   151,   155,   148,   155,   148,    33,   149,   148,   152,
     152,   152,   148,   135,   131,   135,   140,   189,   124,   135,
     187,   189,   148,    94,   157,   157,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,    17,   189,
     160,   124,   189,   189,   194,   184,   121,    33,   135,    91,
     119,   192,   184,   121,    14,    20,   125,   197,   192,   134,
     192,   125,   212,   174,   138,   172,    33,   145,   146,   147,
     121,   121,   153,    91,   119,   119,   125,   119,   121,   126,
     143,   144,   186,   126,   189,   148,   126,   145,   162,   126,
     126,   171,   189,   103,   121,   202,    91,   103,    23,   189,
     192,    61,   143,   198,   199,    94,    59,   125,   189,    86,
      92,   214,   125,    91,    33,   150,   154,   148,    41,    91,
     125,   125,   153,   125,   126,   135,    33,   135,   192,   126,
      59,   148,    94,    91,    94,   194,   135,    92,    17,   109,
     147,    94,   125,   148,   125,   126,   163,   212,   121,   103,
     121,   212,   135,    66,   194,   199,   194,   124,    17,   214,
      17,   148,   125,   135,   124,    33,   213,   189,   189,   121,
     213,   194,   126,   126,   194,   125,   125,    32,    38,    53,
      57,   108,   109,   113,   114,   115,   116,   117,     4,    50,
      66,    67,    92,    93,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   135,    28,    30,    37,    57,    63,    91,   141,
     202,   120,   120,   135,   135,   135,   135,   135,   135,    33,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,    41,   120,    41,   118,    41,   135,   135,    92,
     144,   137,    92,    94,   155,   152,   135,   121,   144,   135,
     135,   121,   119,    68,    69,    72,    73,    74,    75,    76,
      78,    79,    81,    82,    85,   190,   121,    41,    92,    92,
      92,    92,    92,    92,    92,    92,    92,    92,    92,    92,
     138,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   127,   128,   129,   128,   130,   130,   131,   131,   133,
     134,   132,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   136,   135,   135,   135,   135,
     135,   135,   137,   138,   135,   135,   135,   139,   140,   135,
     141,   135,   135,   135,   135,   135,   135,   142,   135,   135,
     135,   135,   143,   143,   144,   144,   145,   145,   146,   146,
     147,   147,   147,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   149,   150,
     148,   148,   151,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   152,   152,   153,   153,   154,   155,
     155,   155,   156,   156,   156,   157,   158,   159,   158,   158,
     158,   158,   158,   160,   158,   161,   162,   163,   158,   164,
     158,   165,   158,   158,   166,   166,   167,   167,   167,   167,
     167,   168,   168,   168,   168,   170,   171,   169,   173,   174,
     172,   175,   176,   177,   177,   178,   178,   179,   180,   180,
     181,   181,   182,   182,   183,   183,   183,   183,   185,   186,
     184,   184,   187,   187,   187,   188,   189,   189,   190,   190,
     191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
     191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
     191,   191,   193,   192,   192,   192,   192,   192,   192,   192,
     192,   192,   192,   192,   192,   192,   192,   192,   192,   192,
     192,   192,   192,   192,   192,   192,   192,   192,   194,   194,
     195,   196,   196,   197,   197,   197,   198,   198,   199,   199,
     200,   200,   200,   200,   201,   201,   202,   204,   203,   206,
     207,   205,   209,   208,   210,   211,   212,   212,   213,   213,
     214,   214,   214
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     3,     2,     0,     1,     0,     0,
       0,     3,     3,     4,     2,     2,     2,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     3,
       4,     4,     1,     3,     4,     0,     6,     3,     3,     3,
       2,     4,     0,     0,     7,     5,     4,     0,     0,     6,
       0,     3,     3,     1,     5,     1,     1,     0,     4,     3,
       3,     3,     3,     1,     1,     0,     1,     2,     1,     3,
       4,     4,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     6,     4,     0,     0,
       6,     4,     0,     5,     1,     3,     3,     2,     4,     4,
       3,     1,     3,     1,     3,     1,     2,     0,     5,     1,
       2,     0,     3,     3,     1,     4,     3,     0,     5,     7,
       7,     7,     7,     0,     9,     0,     0,     0,    12,     0,
       7,     0,     4,     1,     0,     2,     4,     4,     4,     1,
       1,     4,     4,     4,     5,     0,     0,     5,     0,     0,
       5,     3,     2,     3,     0,     3,     1,     2,     1,     0,
       5,     3,     2,     0,     0,     1,     1,     1,     0,     0,
       3,     0,     3,     4,     1,     6,     1,     0,     2,     1,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     1,     3,     3,     1,     1,
       1,     3,     0,     5,     4,     4,     5,     7,     5,     2,
       5,     3,     3,     3,     3,     4,     4,     4,     8,     8,
       5,    11,     6,    12,     5,     3,     1,     1,     2,     0,
       4,     2,     0,     4,     4,     3,     3,     1,     2,     4,
       6,     8,     8,    10,     3,     1,     1,     0,     2,     0,
       0,     3,     0,     2,     1,     1,     1,     0,     1,     0,
       1,     3,     0
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = brolex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* zeek: decl_list stmt_list  */
#line 319 "parse.y"
                        {
			if ( stmts )
				stmts->AsStmtList()->Stmts().push_back((yyvsp[0].stmt));
			else
				stmts = (yyvsp[0].stmt);

			// Any objects creates from here on out should not
			// have file positions associated with them.
			set_location(no_location);
			}
#line 2579 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 3: /* $@1: %empty  */
#line 333 "parse.y"
                          { in_debug = true; }
#line 2585 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 4: /* zeek: TOK_DEBUG $@1 expr  */
#line 334 "parse.y"
                        {
			g_curr_debug_expr = (yyvsp[0].expr);
			}
#line 2593 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 7: /* opt_expr: expr  */
#line 346 "parse.y"
                        { (yyval.expr) = (yyvsp[0].expr); }
#line 2599 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 8: /* opt_expr: %empty  */
#line 348 "parse.y"
                        { (yyval.expr) = 0; }
#line 2605 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 9: /* $@2: %empty  */
#line 352 "parse.y"
                { ++in_when_cond; }
#line 2611 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 10: /* $@3: %empty  */
#line 352 "parse.y"
                                         { --in_when_cond; }
#line 2617 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 11: /* when_condition: $@2 expr $@3  */
#line 353 "parse.y"
                        { (yyval.expr) = (yyvsp[-1].expr); }
#line 2623 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 12: /* expr: '(' expr ')'  */
#line 358 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = (yyvsp[-1].expr); (yyval.expr)->MarkParen();
			}
#line 2632 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 13: /* expr: TOK_COPY '(' expr ')'  */
#line 364 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new CloneExpr({AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 2641 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 14: /* expr: TOK_INCR expr  */
#line 370 "parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_INCR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2650 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 15: /* expr: TOK_DECR expr  */
#line 376 "parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_DECR, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2659 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 16: /* expr: '!' expr  */
#line 382 "parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NotExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2668 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 17: /* expr: '~' expr  */
#line 388 "parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new ComplementExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2677 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 18: /* expr: '-' expr  */
#line 394 "parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NegExpr({AdoptRef{}, (yyvsp[0].expr)});

			if ( ! (yyval.expr)->IsError() && (yyvsp[0].expr)->IsConst() )
				{
				auto v = (yyvsp[0].expr)->ExprVal();
				auto tag = v->GetType()->Tag();

				if ( tag == TYPE_COUNT )
					{
					auto c = v->AsCount();
					uint64_t int_max = static_cast<uint64_t>(INT64_MAX) + 1;

					if ( c <= int_max )
						{
						auto ce = new ConstExpr(val_mgr->Int(-c));
						Unref((yyval.expr));
						(yyval.expr) = ce;
						}
					else
						{
						(yyval.expr)->Error("literal is outside range of 'int' values");
						(yyval.expr)->SetError();
						}
					}
				else
					{
					auto ce = new ConstExpr((yyval.expr)->Eval(nullptr));
					Unref((yyval.expr));
					(yyval.expr) = ce;
					}
				}
			}
#line 2716 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 19: /* expr: '+' expr  */
#line 430 "parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new PosExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2725 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 20: /* expr: expr '+' expr  */
#line 436 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2734 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 21: /* expr: expr TOK_ADD_TO expr  */
#line 442 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddToExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2743 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 22: /* expr: expr '-' expr  */
#line 448 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SubExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2752 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 23: /* expr: expr TOK_REMOVE_FROM expr  */
#line 454 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RemoveFromExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2761 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 24: /* expr: expr '*' expr  */
#line 460 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new TimesExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2770 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 25: /* expr: expr '/' expr  */
#line 466 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new DivideExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2779 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 26: /* expr: expr '%' expr  */
#line 472 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new ModExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2788 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 27: /* expr: expr '&' expr  */
#line 478 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2797 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 28: /* expr: expr '|' expr  */
#line 484 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2806 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 29: /* expr: expr '^' expr  */
#line 490 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_XOR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2815 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 30: /* expr: expr TOK_AND_AND expr  */
#line 496 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_AND_AND, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2824 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 31: /* expr: expr TOK_OR_OR expr  */
#line 502 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_OR_OR, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2833 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 32: /* expr: expr TOK_EQ expr  */
#line 508 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_EQ, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2842 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 33: /* expr: expr TOK_NE expr  */
#line 514 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_NE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2851 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 34: /* expr: expr '<' expr  */
#line 520 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2860 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 35: /* expr: expr TOK_LE expr  */
#line 526 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2869 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 36: /* expr: expr '>' expr  */
#line 532 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GT, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2878 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 37: /* expr: expr TOK_GE expr  */
#line 538 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GE, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2887 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 38: /* expr: expr '?' expr ':' expr  */
#line 544 "parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new CondExpr({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2896 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 39: /* expr: expr '=' expr  */
#line 550 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[-2].expr)->Tag() == EXPR_INDEX && (yyvsp[-2].expr)->AsIndexExpr()->IsSlice() )
				reporter->Error("index slice assignment may not be used"
				                      " in arbitrary expression contexts, only"
				                      " as a statement");

			(yyval.expr) = get_assign_expr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)}, in_init).release();
			}
#line 2911 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 40: /* expr: TOK_LOCAL local_id '=' expr  */
#line 562 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-2].id));
			(yyval.expr) = add_and_assign_local({AdoptRef{}, (yyvsp[-2].id)}, {AdoptRef{}, (yyvsp[0].expr)},
			                                        val_mgr->True()).release();
			}
#line 2923 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 41: /* expr: expr '[' expr_list ']'  */
#line 571 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			if ( in_when_cond > 0 )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].list)});
			}
#line 2935 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 43: /* expr: expr '$' TOK_ID  */
#line 582 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new FieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 2944 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 44: /* expr: '$' TOK_ID '=' expr  */
#line 588 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new FieldAssignExpr((yyvsp[-2].str), {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2953 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 45: /* $@4: %empty  */
#line 594 "parse.y"
                        {
			func_hdr_location = (yylsp[-3]);
			(yyvsp[-1].id)->SetInferReturnType(true);
			}
#line 2962 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 46: /* expr: '$' TOK_ID begin_lambda '=' $@4 lambda_body  */
#line 599 "parse.y"
                        {
			(yyval.expr) = new FieldAssignExpr((yyvsp[-4].str), IntrusivePtr{AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2970 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 47: /* expr: expr TOK_IN expr  */
#line 604 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new InExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].expr)});
			}
#line 2979 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 48: /* expr: expr TOK_NOT_IN expr  */
#line 610 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new NotExpr(make_intrusive<InExpr>(
			        ExprPtr{AdoptRef{}, (yyvsp[-2].expr)},
			        ExprPtr{AdoptRef{}, (yyvsp[0].expr)}));
			}
#line 2990 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 49: /* expr: '[' expr_list ']'  */
#line 618 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));

			bool is_record_ctor = true;

			// If every expression in the list is a field assignment,
			// then treat it as a record constructor, else as a list
			// used for an initializer.

			for ( int i = 0; i < (yyvsp[-1].list)->Exprs().length(); ++i )
				{
				if ( (yyvsp[-1].list)->Exprs()[i]->Tag() != EXPR_FIELD_ASSIGN )
					{
					is_record_ctor = false;
					break;
					}
				}

			if ( is_record_ctor )
				(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			else
				(yyval.expr) = (yyvsp[-1].list);
			}
#line 3018 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 50: /* expr: '[' ']'  */
#line 643 "parse.y"
                        {
			// We interpret this as an empty record constructor.
			(yyval.expr) = new RecordConstructorExpr(make_intrusive<ListExpr>());
			}
#line 3027 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 51: /* expr: TOK_RECORD '(' expr_list ')'  */
#line 650 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new RecordConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3036 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 52: /* $@5: %empty  */
#line 655 "parse.y"
                              { ++in_init; }
#line 3042 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 53: /* $@6: %empty  */
#line 655 "parse.y"
                                                               { --in_init; }
#line 3048 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 54: /* expr: TOK_TABLE '(' $@5 opt_expr_list ')' $@6 opt_attr  */
#line 657 "parse.y"
                        { // the ++in_init fixes up the parsing of "[x] = y"
			set_location((yylsp[-6]), (yylsp[-2]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-3].list)}, std::move(attrs));
			}
#line 3058 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 55: /* expr: TOK_SET '(' opt_expr_list ')' opt_attr  */
#line 664 "parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			std::unique_ptr<std::vector<AttrPtr>> attrs{(yyvsp[0].attr_l)};
			(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, std::move(attrs));
			}
#line 3068 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 56: /* expr: TOK_VECTOR '(' opt_expr_list ')'  */
#line 671 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-1].list)});
			}
#line 3077 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 57: /* $@7: %empty  */
#line 677 "parse.y"
                        {
			if ( expr_is_table_type_name((yyvsp[-1].expr)) )
				++in_init;
			}
#line 3086 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 58: /* $@8: %empty  */
#line 683 "parse.y"
                        {
			if ( expr_is_table_type_name((yyvsp[-3].expr)) )
				--in_init;
			}
#line 3095 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 59: /* expr: expr '(' $@7 opt_expr_list $@8 ')'  */
#line 689 "parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			if ( (yyvsp[-5].expr)->Tag() == EXPR_NAME && (yyvsp[-5].expr)->AsNameExpr()->Id()->IsType() )
				{
				const auto& ctor_type = (yyvsp[-5].expr)->AsNameExpr()->Id()->GetType();

				switch ( ctor_type->Tag() ) {
				case TYPE_RECORD:
					{
					auto rt = cast_intrusive<RecordType>(ctor_type);
					(yyval.expr) = new RecordConstructorExpr(rt, ListExprPtr{AdoptRef{}, (yyvsp[-2].list)});
					}
					break;

				case TYPE_TABLE:
					if ( ctor_type->IsTable() )
						(yyval.expr) = new TableConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);
					else
						(yyval.expr) = new SetConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, 0, ctor_type);

					break;

				case TYPE_VECTOR:
					(yyval.expr) = new VectorConstructorExpr({AdoptRef{}, (yyvsp[-2].list)}, ctor_type);
					break;

				default:
					(yyvsp[-5].expr)->Error("constructor type not implemented");
					YYERROR;
				}
				}

			else
				(yyval.expr) = new CallExpr({AdoptRef{}, (yyvsp[-5].expr)}, {AdoptRef{}, (yyvsp[-2].list)}, in_hook > 0);
			}
#line 3136 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 60: /* $@9: %empty  */
#line 726 "parse.y"
                         { ++in_hook; }
#line 3142 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 61: /* expr: TOK_HOOK $@9 expr  */
#line 727 "parse.y"
                        {
			--in_hook;
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[0].expr)->Tag() != EXPR_CALL )
				(yyvsp[0].expr)->Error("not a valid hook call expression");
			else if ( (yyvsp[0].expr)->AsCallExpr()->Func()->GetType()->AsFuncType()->Flavor() != FUNC_FLAVOR_HOOK )
				(yyvsp[0].expr)->Error("hook keyword should only be used to call hooks");

			(yyval.expr) = (yyvsp[0].expr);
			}
#line 3158 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 62: /* expr: expr TOK_HAS_FIELD TOK_ID  */
#line 740 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new HasFieldExpr({AdoptRef{}, (yyvsp[-2].expr)}, (yyvsp[0].str));
			}
#line 3167 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 64: /* expr: TOK_SCHEDULE expr '{' event '}'  */
#line 749 "parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new ScheduleExpr({AdoptRef{}, (yyvsp[-3].expr)}, {AdoptRef{}, (yyvsp[-1].event_expr)});
			}
#line 3176 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 65: /* expr: TOK_ID  */
#line 755 "parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! id )
				{
				if ( ! in_debug )
					{
/*	// CHECK THAT THIS IS NOT GLOBAL.
					id = install_ID($1, current_module.c_str(),
							        false, is_export);
*/

					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				else
					{
					yyerror(util::fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				}
			else
				{
				if ( id->IsDeprecated() )
					reporter->Warning("%s", id->GetDeprecationWarning().c_str());

				if ( ! id->GetType() )
					{
					id->Error("undeclared variable");
					id->SetType(error_type());
					(yyval.expr) = new NameExpr(std::move(id));
					}

				else if ( id->IsEnumConst() )
					{
					if ( IsErrorType(id->GetType()->Tag()) )
						{
						// The most-relevant error message should already be reported, so
						// just bail out.
						YYERROR;
						}

					EnumType* t = id->GetType()->AsEnumType();
					auto intval = t->Lookup(id->ModuleName(), id->Name());
					if ( intval < 0 )
						reporter->InternalError("enum value not found for %s", id->Name());
					(yyval.expr) = new ConstExpr(t->GetEnumVal(intval));
					}
				else
					{
					if ( out_of_scope_locals.count(id.get()) > 0 &&
					     warned_about_locals.count(id.get()) == 0 )
						{
						// Remove in v5.1
						reporter->Warning("use of out-of-scope local %s deprecated; move declaration to outer scope", id->Name());
						warned_about_locals.insert(id.get());
						}

					(yyval.expr) = new NameExpr(std::move(id));
					}
				}
			}
#line 3244 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 66: /* expr: TOK_CONSTANT  */
#line 820 "parse.y"
                        {
			set_location((yylsp[0]));
			(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			}
#line 3253 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 67: /* $@10: %empty  */
#line 825 "parse.y"
                    { begin_RE(); }
#line 3259 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 68: /* expr: '/' $@10 TOK_PATTERN_TEXT TOK_PATTERN_END  */
#line 826 "parse.y"
                        {
			set_location((yylsp[-1]));

			auto* re = new RE_Matcher((yyvsp[-1].str));
			delete [] (yyvsp[-1].str);

			if ( (yyvsp[0].b) )
				re->MakeCaseInsensitive();

			re->Compile();
			(yyval.expr) = new ConstExpr(make_intrusive<PatternVal>(re));
			}
#line 3276 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 69: /* expr: '|' expr '|'  */
#line 840 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			ExprPtr e{AdoptRef{}, (yyvsp[-1].expr)};
			(yyval.expr) = new SizeExpr(std::move(e));
			}
#line 3286 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 70: /* expr: expr TOK_AS type  */
#line 847 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new CastExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3295 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 71: /* expr: expr TOK_IS type  */
#line 853 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new IsExpr({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].type)});
			}
#line 3304 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 72: /* expr_list: expr_list ',' expr  */
#line 861 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyvsp[-2].list)->Append({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3313 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 73: /* expr_list: expr  */
#line 867 "parse.y"
                        {
			set_location((yylsp[0]));
			(yyval.list) = new ListExpr({AdoptRef{}, (yyvsp[0].expr)});
			}
#line 3322 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 75: /* opt_expr_list: %empty  */
#line 876 "parse.y"
                { (yyval.list) = new ListExpr(); }
#line 3328 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 76: /* enum_body: enum_body_list  */
#line 881 "parse.y"
                        {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3337 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 77: /* enum_body: enum_body_list ','  */
#line 887 "parse.y"
                        {
			(yyval.type) = cur_enum_type;
			cur_enum_type = nullptr;
			}
#line 3346 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 80: /* enum_body_elem: TOK_ID '=' TOK_CONSTANT opt_deprecated  */
#line 906 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			assert(cur_enum_type);

			if ( (yyvsp[-1].val)->GetType()->Tag() != TYPE_COUNT )
				reporter->Error("enumerator is not a count constant");
			else
				cur_enum_type->AddName(current_module, (yyvsp[-3].str),
				                       (yyvsp[-1].val)->InternalUnsigned(), is_export, (yyvsp[0].expr),
				                       in_enum_redef != 0);
			}
#line 3362 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 81: /* enum_body_elem: TOK_ID '=' '-' TOK_CONSTANT  */
#line 919 "parse.y"
                        {
			// We only accept counts as enumerator, but we want to return a nice
			// error message if users triy to use a negative integer (will also
			// catch other cases, but that's fine.)
			reporter->Error("enumerator is not a count constant");
			}
#line 3373 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 82: /* enum_body_elem: TOK_ID opt_deprecated  */
#line 927 "parse.y"
                        {
			set_location((yylsp[-1]));
			assert(cur_enum_type);
			cur_enum_type->AddName(current_module, (yyvsp[-1].str), is_export, (yyvsp[0].expr),
			                       in_enum_redef != 0);
			}
#line 3384 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 83: /* type: TOK_BOOL  */
#line 936 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_BOOL)->Ref();
				}
#line 3393 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 84: /* type: TOK_INT  */
#line 941 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INT)->Ref();
				}
#line 3402 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 85: /* type: TOK_COUNT  */
#line 946 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNT)->Ref();
				}
#line 3411 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 86: /* type: TOK_DOUBLE  */
#line 951 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_DOUBLE)->Ref();
				}
#line 3420 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 87: /* type: TOK_TIME  */
#line 956 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIME)->Ref();
				}
#line 3429 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 88: /* type: TOK_INTERVAL  */
#line 961 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INTERVAL)->Ref();
				}
#line 3438 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 89: /* type: TOK_STRING  */
#line 966 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_STRING)->Ref();
				}
#line 3447 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 90: /* type: TOK_PATTERN  */
#line 971 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PATTERN)->Ref();
				}
#line 3456 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 91: /* type: TOK_TIMER  */
#line 976 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIMER)->Ref();
				}
#line 3465 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 92: /* type: TOK_PORT  */
#line 981 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PORT)->Ref();
				}
#line 3474 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 93: /* type: TOK_ADDR  */
#line 986 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ADDR)->Ref();
				}
#line 3483 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 94: /* type: TOK_SUBNET  */
#line 991 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_SUBNET)->Ref();
				}
#line 3492 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 95: /* type: TOK_ANY  */
#line 996 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ANY)->Ref();
				}
#line 3501 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 96: /* type: TOK_TABLE '[' type_list ']' TOK_OF type  */
#line 1002 "parse.y"
                                {
				set_location((yylsp[-5]), (yylsp[0]));
				(yyval.type) = new TableType({AdoptRef{}, (yyvsp[-3].type_l)}, {AdoptRef{}, (yyvsp[0].type)});
				}
#line 3510 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 97: /* type: TOK_SET '[' type_list ']'  */
#line 1008 "parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[0]));
				(yyval.type) = new SetType({AdoptRef{}, (yyvsp[-1].type_l)}, nullptr);
				}
#line 3519 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 98: /* $@11: %empty  */
#line 1014 "parse.y"
                        { ++in_record; }
#line 3525 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 99: /* $@12: %empty  */
#line 1016 "parse.y"
                        { --in_record; }
#line 3531 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 100: /* type: TOK_RECORD '{' $@11 type_decl_list $@12 '}'  */
#line 1018 "parse.y"
                                {
				set_location((yylsp[-5]), (yylsp[-1]));
				(yyval.type) = new RecordType((yyvsp[-2].type_decl_l));
				}
#line 3540 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 101: /* type: TOK_UNION '{' type_list '}'  */
#line 1024 "parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[0]));
				reporter->Error("union type not implemented");
				(yyval.type) = 0;
				}
#line 3550 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 102: /* $@13: %empty  */
#line 1030 "parse.y"
                             { set_location((yylsp[-1])); parse_new_enum(); }
#line 3556 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 103: /* type: TOK_ENUM '{' $@13 enum_body '}'  */
#line 1031 "parse.y"
                                {
				set_location((yylsp[-4]), (yylsp[0]));
				(yyvsp[-1].type)->UpdateLocationEndInfo((yylsp[0]));
				(yyval.type) = (yyvsp[-1].type);
				}
#line 3566 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 104: /* type: TOK_LIST  */
#line 1038 "parse.y"
                                {
				set_location((yylsp[0]));
				// $$ = new TypeList();
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3577 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 105: /* type: TOK_LIST TOK_OF type  */
#line 1046 "parse.y"
                                {
				set_location((yylsp[-2]));
				// $$ = new TypeList($3);
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3588 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 106: /* type: TOK_VECTOR TOK_OF type  */
#line 1054 "parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new VectorType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3597 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 107: /* type: TOK_FUNCTION func_params  */
#line 1060 "parse.y"
                                {
				set_location((yylsp[-1]), (yylsp[0]));
				(yyval.type) = (yyvsp[0].func_type);
				}
#line 3606 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 108: /* type: TOK_EVENT '(' formal_args ')'  */
#line 1066 "parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, nullptr, FUNC_FLAVOR_EVENT);
				}
#line 3615 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 109: /* type: TOK_HOOK '(' formal_args ')'  */
#line 1072 "parse.y"
                                {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_BOOL), FUNC_FLAVOR_HOOK);
				}
#line 3624 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 110: /* type: TOK_FILE TOK_OF type  */
#line 1078 "parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new FileType({AdoptRef{}, (yyvsp[0].type)});
				}
#line 3633 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 111: /* type: TOK_FILE  */
#line 1084 "parse.y"
                                {
				set_location((yylsp[0]));
				(yyval.type) = new FileType(base_type(TYPE_STRING));
				}
#line 3642 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 112: /* type: TOK_OPAQUE TOK_OF TOK_ID  */
#line 1090 "parse.y"
                                {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new OpaqueType((yyvsp[0].str));
				}
#line 3651 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 113: /* type: resolve_id  */
#line 1096 "parse.y"
                        {
			if ( ! (yyvsp[0].id) || ! ((yyval.type) = (yyvsp[0].id)->IsType() ? (yyvsp[0].id)->GetType().get() : nullptr) )
				{
				NullStmt here;
				if ( (yyvsp[0].id) )
					(yyvsp[0].id)->Error("not a Zeek type", &here);
				(yyval.type) = error_type()->Ref();
				}
			else
				{
				Ref((yyval.type));

				if ( (yyvsp[0].id)->IsDeprecated() )
					reporter->Warning("%s", (yyvsp[0].id)->GetDeprecationWarning().c_str());
				}
			}
#line 3672 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 114: /* type_list: type_list ',' type  */
#line 1116 "parse.y"
                        { (yyvsp[-2].type_l)->AppendEvenIfNotPure({AdoptRef{}, (yyvsp[0].type)}); }
#line 3678 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 115: /* type_list: type  */
#line 1118 "parse.y"
                        {
			(yyval.type_l) = new TypeList({NewRef{}, (yyvsp[0].type)});
			(yyval.type_l)->Append({AdoptRef{}, (yyvsp[0].type)});
			}
#line 3687 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 116: /* type_decl_list: type_decl_list type_decl  */
#line 1126 "parse.y"
                        {
			(yyvsp[-1].type_decl_l)->push_back((yyvsp[0].type_decl));
			}
#line 3695 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 117: /* type_decl_list: %empty  */
#line 1130 "parse.y"
                        {
			(yyval.type_decl_l) = new type_decl_list();
			}
#line 3703 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 118: /* type_decl: TOK_ID ':' type opt_attr ';'  */
#line 1137 "parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			auto attrs = make_attributes((yyvsp[-1].attr_l), {NewRef{}, (yyvsp[-2].type)}, in_record > 0, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-4].str), {AdoptRef{}, (yyvsp[-2].type)}, std::move(attrs));

			if ( in_record > 0 && cur_decl_type_id )
				zeekygen_mgr->RecordField(cur_decl_type_id, (yyval.type_decl), ::filename,
				                                        in_record_redef != 0);
			}
#line 3717 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 119: /* formal_args: formal_args_decl_list  */
#line 1150 "parse.y"
                        { (yyval.record) = new RecordType((yyvsp[0].type_decl_l)); }
#line 3723 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 120: /* formal_args: formal_args_decl_list ';'  */
#line 1152 "parse.y"
                        { (yyval.record) = new RecordType((yyvsp[-1].type_decl_l)); }
#line 3729 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 121: /* formal_args: %empty  */
#line 1154 "parse.y"
                        { (yyval.record) = new RecordType(new type_decl_list()); }
#line 3735 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 122: /* formal_args_decl_list: formal_args_decl_list ';' formal_args_decl  */
#line 1159 "parse.y"
                        { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3741 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 123: /* formal_args_decl_list: formal_args_decl_list ',' formal_args_decl  */
#line 1161 "parse.y"
                        { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3747 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 124: /* formal_args_decl_list: formal_args_decl  */
#line 1163 "parse.y"
                        { (yyval.type_decl_l) = new type_decl_list(); (yyval.type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3753 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 125: /* formal_args_decl: TOK_ID ':' type opt_attr  */
#line 1168 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			auto attrs = make_attributes((yyvsp[0].attr_l), {NewRef{}, (yyvsp[-1].type)}, true, false);
			(yyval.type_decl) = new TypeDecl((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].type)}, std::move(attrs));
			}
#line 3763 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 126: /* decl: TOK_MODULE TOK_ID ';'  */
#line 1177 "parse.y"
                        {
			current_module = (yyvsp[-1].str);
			zeekygen_mgr->ModuleUsage(::filename, current_module);
			}
#line 3772 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 127: /* $@14: %empty  */
#line 1182 "parse.y"
                               { is_export = true; }
#line 3778 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 128: /* decl: TOK_EXPORT '{' $@14 decl_list '}'  */
#line 1183 "parse.y"
                        { is_export = false; }
#line 3784 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 129: /* decl: TOK_GLOBAL def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1186 "parse.y"
                        {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REGULAR);
			}
#line 3792 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 130: /* decl: TOK_OPTION def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1191 "parse.y"
                        {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_OPTION);
			}
#line 3800 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 131: /* decl: TOK_CONST def_global_id opt_type init_class opt_init opt_attr ';'  */
#line 1196 "parse.y"
                        {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_CONST);
			}
#line 3808 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 132: /* decl: TOK_REDEF global_id opt_type init_class opt_init opt_attr ';'  */
#line 1201 "parse.y"
                        {
			build_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REDEF);
			}
#line 3816 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 133: /* $@15: %empty  */
#line 1206 "parse.y"
                        { ++in_enum_redef; parse_redef_enum((yyvsp[-2].id)); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename); }
#line 3822 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 134: /* decl: TOK_REDEF TOK_ENUM global_id TOK_ADD_TO '{' $@15 enum_body '}' ';'  */
#line 1208 "parse.y"
                        {
			--in_enum_redef;
			// Zeekygen already grabbed new enum IDs as the type created them.
			}
#line 3831 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 135: /* $@16: %empty  */
#line 1214 "parse.y"
                        { cur_decl_type_id = (yyvsp[0].id); zeekygen_mgr->Redef((yyvsp[0].id), ::filename); }
#line 3837 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 136: /* $@17: %empty  */
#line 1216 "parse.y"
                        { ++in_record; ++in_record_redef; }
#line 3843 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 137: /* $@18: %empty  */
#line 1218 "parse.y"
                        { --in_record; --in_record_redef; }
#line 3849 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 138: /* decl: TOK_REDEF TOK_RECORD global_id $@16 TOK_ADD_TO '{' $@17 type_decl_list $@18 '}' opt_attr ';'  */
#line 1220 "parse.y"
                        {
			cur_decl_type_id = 0;

			if ( ! (yyvsp[-9].id)->GetType() )
				(yyvsp[-9].id)->Error("unknown identifier");
			else
				extend_record((yyvsp[-9].id), std::unique_ptr<type_decl_list>((yyvsp[-4].type_decl_l)),
				              std::unique_ptr<std::vector<AttrPtr>>((yyvsp[-1].attr_l)));
			}
#line 3863 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 139: /* $@19: %empty  */
#line 1231 "parse.y"
                        { cur_decl_type_id = (yyvsp[-1].id); zeekygen_mgr->StartType({NewRef{}, (yyvsp[-1].id)});  }
#line 3869 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 140: /* decl: TOK_TYPE global_id ':' $@19 type opt_attr ';'  */
#line 1233 "parse.y"
                        {
			cur_decl_type_id = 0;
			IntrusivePtr id{AdoptRef{}, (yyvsp[-5].id)};
			add_type(id.get(), {AdoptRef{}, (yyvsp[-2].type)},
			                       std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[-1].attr_l)});
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 3881 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 141: /* $@20: %empty  */
#line 1242 "parse.y"
                        {
			func_hdr_location = (yylsp[0]);
			func_hdr_cond_epoch = conditional_epoch;
			}
#line 3890 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 146: /* conditional: TOK_ATIF '(' expr ')'  */
#line 1257 "parse.y"
                        { do_atif((yyvsp[-1].expr)); }
#line 3896 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 147: /* conditional: TOK_ATIFDEF '(' TOK_ID ')'  */
#line 1259 "parse.y"
                        { do_atifdef((yyvsp[-1].str)); }
#line 3902 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 148: /* conditional: TOK_ATIFNDEF '(' TOK_ID ')'  */
#line 1261 "parse.y"
                        { do_atifndef((yyvsp[-1].str)); }
#line 3908 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 149: /* conditional: TOK_ATENDIF  */
#line 1263 "parse.y"
                        { do_atendif(); }
#line 3914 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 150: /* conditional: TOK_ATELSE  */
#line 1265 "parse.y"
                        { do_atelse(); }
#line 3920 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 151: /* func_hdr: TOK_FUNCTION def_global_id func_params opt_attr  */
#line 1270 "parse.y"
                        {
			IntrusivePtr id{AdoptRef{}, (yyvsp[-2].id)};
			begin_func(id, current_module.c_str(),
				                     FUNC_FLAVOR_FUNCTION, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			zeekygen_mgr->Identifier(std::move(id));
			}
#line 3933 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 152: /* func_hdr: TOK_EVENT event_id func_params opt_attr  */
#line 1279 "parse.y"
                        {
			const char* name = (yyvsp[-2].id)->Name();
			if ( util::streq("bro_init", name) || util::streq("bro_done", name) || util::streq("bro_script_loaded", name) )
				{
				auto base = std::string(name).substr(4);
				reporter->Error("event %s() is no longer available, use zeek_%s() instead", name, base.c_str());
				}

			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3951 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 153: /* func_hdr: TOK_HOOK def_global_id func_params opt_attr  */
#line 1293 "parse.y"
                        {
			(yyvsp[-1].func_type)->ClearYieldType(FUNC_FLAVOR_HOOK);
			(yyvsp[-1].func_type)->SetYieldType(base_type(TYPE_BOOL));
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_HOOK, false, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3964 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 154: /* func_hdr: TOK_REDEF TOK_EVENT event_id func_params opt_attr  */
#line 1302 "parse.y"
                        {
			begin_func({NewRef{}, (yyvsp[-2].id)}, current_module.c_str(),
				                     FUNC_FLAVOR_EVENT, true, {NewRef{}, (yyvsp[-1].func_type)},
			                         std::unique_ptr<std::vector<AttrPtr>>{(yyvsp[0].attr_l)});
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3975 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 155: /* $@21: %empty  */
#line 1312 "parse.y"
                        {
			saved_in_init.push_back(in_init);
			in_init = 0;

			locals_at_this_scope.clear();
			out_of_scope_locals.clear();
			warned_about_locals.clear();
			}
#line 3988 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 156: /* $@22: %empty  */
#line 1322 "parse.y"
                        {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 3997 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 157: /* func_body: '{' $@21 stmt_list $@22 '}'  */
#line 1328 "parse.y"
                        {
			set_location(func_hdr_location, (yylsp[0]));

			bool free_of_conditionals = true;
			if ( current_file_has_conditionals ||
			     conditional_epoch > func_hdr_cond_epoch )
				free_of_conditionals = false;

			end_func({AdoptRef{}, (yyvsp[-2].stmt)}, free_of_conditionals);
			}
#line 4012 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 158: /* $@23: %empty  */
#line 1342 "parse.y"
                        {
			saved_in_init.push_back(in_init);
			in_init = 0;
			}
#line 4021 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 159: /* $@24: %empty  */
#line 1348 "parse.y"
                        {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 4030 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 160: /* lambda_body: '{' $@23 stmt_list $@24 '}'  */
#line 1354 "parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[0]));

			// Code duplication here is sad but needed.
			// end_func actually instantiates the function
			// and associates it with an ID. We perform that
			// association later and need to return a lambda
			// expression.

			// Gather the ingredients for a Func from the
			// current scope.
			auto ingredients = std::make_unique<function_ingredients>(
				current_scope(), IntrusivePtr{AdoptRef{}, (yyvsp[-2].stmt)});
			auto outer_ids = gather_outer_ids(pop_scope(), ingredients->body);

			(yyval.expr) = new LambdaExpr(std::move(ingredients), std::move(outer_ids));
			}
#line 4052 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 161: /* anonymous_function: TOK_FUNCTION begin_lambda lambda_body  */
#line 1375 "parse.y"
                        { (yyval.expr) = (yyvsp[0].expr); }
#line 4058 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 162: /* begin_lambda: opt_captures func_params  */
#line 1380 "parse.y"
                        {
			auto id = current_scope()->GenerateTemporary("anonymous-function");
			begin_func(id, current_module.c_str(), FUNC_FLAVOR_FUNCTION, false, {AdoptRef{}, (yyvsp[0].func_type)});

			std::optional<FuncType::CaptureList> captures;

			if ( (yyvsp[-1].captures) )
				{
				captures = FuncType::CaptureList{};
				captures->reserve((yyvsp[-1].captures)->size());

				for ( auto c : *(yyvsp[-1].captures) )
					{
					captures->emplace_back(*c);
					delete c;
					}

				delete (yyvsp[-1].captures);
				}

			(yyvsp[0].func_type)->SetCaptures(std::move(captures));
			(yyval.id) = id.release();
			}
#line 4086 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 163: /* opt_captures: '[' capture_list ']'  */
#line 1407 "parse.y"
                        { (yyval.captures) = (yyvsp[-1].captures); }
#line 4092 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 164: /* opt_captures: %empty  */
#line 1409 "parse.y"
                        { (yyval.captures) = nullptr; }
#line 4098 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 165: /* capture_list: capture_list ',' capture  */
#line 1414 "parse.y"
                        { (yyvsp[-2].captures)->push_back((yyvsp[0].capture)); }
#line 4104 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 166: /* capture_list: capture  */
#line 1416 "parse.y"
                        {
			(yyval.captures) = new std::vector<FuncType::Capture*>;
			(yyval.captures)->push_back((yyvsp[0].capture));
			}
#line 4113 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 167: /* capture: opt_deep TOK_ID  */
#line 1424 "parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str),
					current_module.c_str());

			if ( ! id )
				reporter->Error("no such local identifier: %s", (yyvsp[0].str));
			else if ( id->IsType() )
				{
				reporter->Error("cannot specify type in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}
			else if ( id->IsGlobal() )
				{
				reporter->Error("cannot specify global in capture: %s", (yyvsp[0].str));
				id = nullptr;
				}

			delete [] (yyvsp[0].str);

			(yyval.capture) = new FuncType::Capture;
			(yyval.capture)->id = id;
			(yyval.capture)->deep_copy = (yyvsp[-1].b);
			}
#line 4142 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 168: /* opt_deep: TOK_COPY  */
#line 1451 "parse.y"
                        { (yyval.b) = true; }
#line 4148 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 169: /* opt_deep: %empty  */
#line 1453 "parse.y"
                        { (yyval.b) = false; }
#line 4154 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 170: /* func_params: '(' formal_args ')' ':' type  */
#line 1458 "parse.y"
                        { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-3].record)}, {AdoptRef{}, (yyvsp[0].type)}, FUNC_FLAVOR_FUNCTION); }
#line 4160 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 171: /* func_params: '(' formal_args ')'  */
#line 1460 "parse.y"
                        { (yyval.func_type) = new FuncType({AdoptRef{}, (yyvsp[-1].record)}, base_type(TYPE_VOID), FUNC_FLAVOR_FUNCTION); }
#line 4166 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 172: /* opt_type: ':' type  */
#line 1465 "parse.y"
                        { (yyval.type) = (yyvsp[0].type); }
#line 4172 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 173: /* opt_type: %empty  */
#line 1467 "parse.y"
                        { (yyval.type) = 0; }
#line 4178 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 174: /* init_class: %empty  */
#line 1471 "parse.y"
                                { (yyval.ic) = INIT_NONE; }
#line 4184 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 175: /* init_class: '='  */
#line 1472 "parse.y"
                                { (yyval.ic) = INIT_FULL; }
#line 4190 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 176: /* init_class: TOK_ADD_TO  */
#line 1473 "parse.y"
                                { (yyval.ic) = INIT_EXTRA; }
#line 4196 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 177: /* init_class: TOK_REMOVE_FROM  */
#line 1474 "parse.y"
                                { (yyval.ic) = INIT_REMOVE; }
#line 4202 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 178: /* $@25: %empty  */
#line 1478 "parse.y"
                { ++in_init; }
#line 4208 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 179: /* $@26: %empty  */
#line 1478 "parse.y"
                                    { --in_init; }
#line 4214 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 180: /* opt_init: $@25 init $@26  */
#line 1479 "parse.y"
                        { (yyval.expr) = (yyvsp[-1].expr); }
#line 4220 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 181: /* opt_init: %empty  */
#line 1481 "parse.y"
                        { (yyval.expr) = 0; }
#line 4226 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 182: /* init: '{' opt_expr_list '}'  */
#line 1486 "parse.y"
                        { (yyval.expr) = (yyvsp[-1].list); }
#line 4232 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 183: /* init: '{' expr_list ',' '}'  */
#line 1488 "parse.y"
                        { (yyval.expr) = (yyvsp[-2].list); }
#line 4238 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 185: /* index_slice: expr '[' opt_expr ':' opt_expr ']'  */
#line 1494 "parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			auto low = (yyvsp[-3].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-3].expr)} :
			                make_intrusive<ConstExpr>(val_mgr->Count(0));

			auto high = (yyvsp[-1].expr) ? ExprPtr{AdoptRef{}, (yyvsp[-1].expr)} :
			                 make_intrusive<SizeExpr>(
			                     ExprPtr{NewRef{}, (yyvsp[-5].expr)});

			if ( ! IsIntegral(low->GetType()->Tag()) || ! IsIntegral(high->GetType()->Tag()) )
				reporter->Error("slice notation must have integral values as indexes");

			auto le = make_intrusive<ListExpr>(std::move(low));
			le->Append(std::move(high));

			if ( in_when_cond > 0  )
				(yyval.expr) = new IndexExprWhen({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			else
				(yyval.expr) = new IndexExpr({AdoptRef{}, (yyvsp[-5].expr)}, std::move(le), true);
			}
#line 4264 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 187: /* opt_attr: %empty  */
#line 1519 "parse.y"
                        { (yyval.attr_l) = nullptr; }
#line 4270 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 188: /* attr_list: attr_list attr  */
#line 1524 "parse.y"
                        { (yyvsp[-1].attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr)); }
#line 4276 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 189: /* attr_list: attr  */
#line 1526 "parse.y"
                        {
			(yyval.attr_l) = new std::vector<AttrPtr>;
			(yyval.attr_l)->emplace_back(AdoptRef{}, (yyvsp[0].attr));
			}
#line 4285 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 190: /* attr: TOK_ATTR_DEFAULT '=' expr  */
#line 1534 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEFAULT, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4291 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 191: /* attr: TOK_ATTR_OPTIONAL  */
#line 1536 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_OPTIONAL); }
#line 4297 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 192: /* attr: TOK_ATTR_REDEF  */
#line 1538 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_REDEF); }
#line 4303 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 193: /* attr: TOK_ATTR_IS_ASSIGNED  */
#line 1540 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_IS_ASSIGNED); }
#line 4309 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 194: /* attr: TOK_ATTR_IS_USED  */
#line 1542 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_IS_USED); }
#line 4315 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 195: /* attr: TOK_ATTR_ADD_FUNC '=' expr  */
#line 1544 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_ADD_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4321 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 196: /* attr: TOK_ATTR_DEL_FUNC '=' expr  */
#line 1546 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEL_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4327 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 197: /* attr: TOK_ATTR_ON_CHANGE '=' expr  */
#line 1548 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_ON_CHANGE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4333 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 198: /* attr: TOK_ATTR_BROKER_STORE '=' expr  */
#line 1550 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_BROKER_STORE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4339 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 199: /* attr: TOK_ATTR_BROKER_STORE_ALLOW_COMPLEX  */
#line 1552 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_BROKER_STORE_ALLOW_COMPLEX); }
#line 4345 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 200: /* attr: TOK_ATTR_BACKEND '=' expr  */
#line 1554 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_BACKEND, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4351 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 201: /* attr: TOK_ATTR_EXPIRE_FUNC '=' expr  */
#line 1556 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_FUNC, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4357 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 202: /* attr: TOK_ATTR_EXPIRE_CREATE '=' expr  */
#line 1558 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_CREATE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4363 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 203: /* attr: TOK_ATTR_EXPIRE_READ '=' expr  */
#line 1560 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_READ, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4369 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 204: /* attr: TOK_ATTR_EXPIRE_WRITE '=' expr  */
#line 1562 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_EXPIRE_WRITE, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4375 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 205: /* attr: TOK_ATTR_RAW_OUTPUT  */
#line 1564 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_RAW_OUTPUT); }
#line 4381 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 206: /* attr: TOK_ATTR_PRIORITY '=' expr  */
#line 1566 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_PRIORITY, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4387 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 207: /* attr: TOK_ATTR_TYPE_COLUMN '=' expr  */
#line 1568 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_TYPE_COLUMN, {AdoptRef{}, (yyvsp[0].expr)}); }
#line 4393 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 208: /* attr: TOK_ATTR_LOG  */
#line 1570 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_LOG); }
#line 4399 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 209: /* attr: TOK_ATTR_ERROR_HANDLER  */
#line 1572 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_ERROR_HANDLER); }
#line 4405 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 210: /* attr: TOK_ATTR_DEPRECATED  */
#line 1574 "parse.y"
                        { (yyval.attr) = new Attr(ATTR_DEPRECATED); }
#line 4411 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 211: /* attr: TOK_ATTR_DEPRECATED '=' TOK_CONSTANT  */
#line 1576 "parse.y"
                        {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.attr) = new Attr(
					ATTR_DEPRECATED,
					make_intrusive<ConstExpr>(IntrusivePtr{AdoptRef{}, (yyvsp[0].val)}));
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				Unref((yyvsp[0].val));
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.attr) = new Attr(ATTR_DEPRECATED);
				}
			}
#line 4431 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 212: /* $@27: %empty  */
#line 1595 "parse.y"
                        {
			std::set<const ID*> id_set;
			locals_at_this_scope.emplace_back(id_set);
			}
#line 4440 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 213: /* stmt: '{' $@27 opt_no_test_block stmt_list '}'  */
#line 1600 "parse.y"
                        {
			auto& scope_locals = locals_at_this_scope.back();
			out_of_scope_locals.insert(scope_locals.begin(), scope_locals.end());
			locals_at_this_scope.pop_back();

			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.stmt) = (yyvsp[-1].stmt);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4455 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 214: /* stmt: TOK_PRINT expr_list ';' opt_no_test  */
#line 1612 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new PrintStmt(IntrusivePtr{AdoptRef{}, (yyvsp[-2].list)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4466 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 215: /* stmt: TOK_EVENT event ';' opt_no_test  */
#line 1620 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new EventStmt({AdoptRef{}, (yyvsp[-2].event_expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4477 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 216: /* stmt: TOK_IF '(' expr ')' stmt  */
#line 1628 "parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)}, make_intrusive<NullStmt>());
			}
#line 4486 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 217: /* stmt: TOK_IF '(' expr ')' stmt TOK_ELSE stmt  */
#line 1634 "parse.y"
                        {
			set_location((yylsp[-6]), (yylsp[-3]));
			(yyval.stmt) = new IfStmt({AdoptRef{}, (yyvsp[-4].expr)}, {AdoptRef{}, (yyvsp[-2].stmt)}, {AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 4495 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 218: /* stmt: TOK_SWITCH expr '{' case_list '}'  */
#line 1640 "parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-3]));
			(yyval.stmt) = new SwitchStmt({AdoptRef{}, (yyvsp[-3].expr)}, (yyvsp[-1].case_l));
			}
#line 4504 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 219: /* stmt: for_head stmt  */
#line 1646 "parse.y"
                        {
			(yyvsp[-1].stmt)->AsForStmt()->AddBody({AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 4512 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 220: /* stmt: TOK_WHILE '(' expr ')' stmt  */
#line 1651 "parse.y"
                        {
			(yyval.stmt) = new WhileStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)});
			}
#line 4520 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 221: /* stmt: TOK_NEXT ';' opt_no_test  */
#line 1656 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new NextStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4531 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 222: /* stmt: TOK_BREAK ';' opt_no_test  */
#line 1664 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new BreakStmt;
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4542 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 223: /* stmt: TOK_FALLTHROUGH ';' opt_no_test  */
#line 1672 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new FallthroughStmt;
			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4553 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 224: /* stmt: TOK_RETURN ';' opt_no_test  */
#line 1680 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ReturnStmt(0);
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4564 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 225: /* stmt: TOK_RETURN expr ';' opt_no_test  */
#line 1688 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-2]));
			(yyval.stmt) = new ReturnStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4575 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 226: /* stmt: TOK_ADD expr ';' opt_no_test  */
#line 1696 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new AddStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4586 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 227: /* stmt: TOK_DELETE expr ';' opt_no_test  */
#line 1704 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new DelStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4597 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 228: /* stmt: TOK_LOCAL local_id opt_type init_class opt_init opt_attr ';' opt_no_test  */
#line 1712 "parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[-1]));
			if ( ! locals_at_this_scope.empty() )
			       locals_at_this_scope.back().insert((yyvsp[-6].id));
			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_REGULAR, ! (yyvsp[0].b)).release();
			}
#line 4608 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 229: /* stmt: TOK_CONST local_id opt_type init_class opt_init opt_attr ';' opt_no_test  */
#line 1720 "parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[-2]));
			(yyval.stmt) = build_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_CONST, ! (yyvsp[0].b)).release();
			}
#line 4617 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 230: /* stmt: TOK_WHEN '(' when_condition ')' stmt  */
#line 1726 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)},
			                                  nullptr, nullptr, false);
			}
#line 4627 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 231: /* stmt: TOK_WHEN '(' when_condition ')' stmt TOK_TIMEOUT expr '{' opt_no_test_block stmt_list '}'  */
#line 1733 "parse.y"
                        {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt({AdoptRef{}, (yyvsp[-8].expr)}, {AdoptRef{}, (yyvsp[-6].stmt)},
			                                  {AdoptRef{}, (yyvsp[-1].stmt)}, {AdoptRef{}, (yyvsp[-4].expr)}, false);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4639 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 232: /* stmt: TOK_RETURN TOK_WHEN '(' when_condition ')' stmt  */
#line 1743 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt({AdoptRef{}, (yyvsp[-2].expr)}, {AdoptRef{}, (yyvsp[0].stmt)}, nullptr,
			                  nullptr, true);
			}
#line 4649 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 233: /* stmt: TOK_RETURN TOK_WHEN '(' when_condition ')' stmt TOK_TIMEOUT expr '{' opt_no_test_block stmt_list '}'  */
#line 1750 "parse.y"
                        {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt({AdoptRef{}, (yyvsp[-8].expr)}, {AdoptRef{}, (yyvsp[-6].stmt)},
			                                  {AdoptRef{}, (yyvsp[-1].stmt)}, {AdoptRef{}, (yyvsp[-4].expr)}, true);
			if ( (yyvsp[-2].b) )
			    script_coverage_mgr.DecIgnoreDepth();
			}
#line 4661 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 234: /* stmt: index_slice '=' expr ';' opt_no_test  */
#line 1759 "parse.y"
                        {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt(get_assign_expr({AdoptRef{}, (yyvsp[-4].expr)},
			                                  {AdoptRef{}, (yyvsp[-2].expr)}, in_init));

			if ( ! (yyvsp[0].b) )
				script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4674 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 235: /* stmt: expr ';' opt_no_test  */
#line 1769 "parse.y"
                        {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt({AdoptRef{}, (yyvsp[-2].expr)});
			if ( ! (yyvsp[0].b) )
			    script_coverage_mgr.AddStmt((yyval.stmt));
			}
#line 4685 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 236: /* stmt: ';'  */
#line 1777 "parse.y"
                        {
			set_location((yylsp[0]), (yylsp[0]));
			(yyval.stmt) = new NullStmt;
			}
#line 4694 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 237: /* stmt: conditional  */
#line 1783 "parse.y"
                        { (yyval.stmt) = new NullStmt; }
#line 4700 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 238: /* stmt_list: stmt_list stmt  */
#line 1788 "parse.y"
                        {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].stmt)->AsStmtList()->Stmts().push_back((yyvsp[0].stmt));
			(yyvsp[-1].stmt)->UpdateLocationEndInfo((yylsp[0]));
			}
#line 4710 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 239: /* stmt_list: %empty  */
#line 1794 "parse.y"
                        { (yyval.stmt) = new StmtList(); }
#line 4716 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 240: /* event: TOK_ID '(' opt_expr_list ')'  */
#line 1799 "parse.y"
                        {
			set_location((yylsp[-3]), (yylsp[0]));
			const auto& id = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( id )
				{
				if ( ! id->IsGlobal() )
					{
					yyerror(util::fmt("local identifier \"%s\" cannot be used to reference an event", (yyvsp[-3].str)));
					YYERROR;
					}

				if ( id->IsDeprecated() )
					reporter->Warning("%s", id->GetDeprecationWarning().c_str());
				}

			(yyval.event_expr) = new EventExpr((yyvsp[-3].str), {AdoptRef{}, (yyvsp[-1].list)});
			}
#line 4739 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 241: /* case_list: case_list case  */
#line 1821 "parse.y"
                        { (yyvsp[-1].case_l)->push_back((yyvsp[0].c_case)); }
#line 4745 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 242: /* case_list: %empty  */
#line 1823 "parse.y"
                        { (yyval.case_l) = new case_list; }
#line 4751 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 243: /* case: TOK_CASE expr_list ':' stmt_list  */
#line 1828 "parse.y"
                        { (yyval.c_case) = new Case({AdoptRef{}, (yyvsp[-2].list)}, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4757 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 244: /* case: TOK_CASE case_type_list ':' stmt_list  */
#line 1831 "parse.y"
                        { (yyval.c_case) = new Case(nullptr, (yyvsp[-2].id_l), {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4763 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 245: /* case: TOK_DEFAULT ':' stmt_list  */
#line 1834 "parse.y"
                        { (yyval.c_case) = new Case(nullptr, nullptr, {AdoptRef{}, (yyvsp[0].stmt)}); }
#line 4769 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 246: /* case_type_list: case_type_list ',' case_type  */
#line 1839 "parse.y"
                        { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 4775 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 247: /* case_type_list: case_type  */
#line 1842 "parse.y"
                        {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 4784 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 248: /* case_type: TOK_TYPE type  */
#line 1850 "parse.y"
                        {
			(yyval.id) = new ID(0, SCOPE_FUNCTION, 0);
			(yyval.id)->SetType({AdoptRef{}, (yyvsp[0].type)});
			}
#line 4793 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 249: /* case_type: TOK_TYPE type TOK_AS TOK_ID  */
#line 1856 "parse.y"
                        {
			const char* name = (yyvsp[0].str);
			TypePtr type{AdoptRef{}, (yyvsp[-2].type)};
			auto case_var = lookup_ID(name, current_module.c_str());

			if ( case_var && case_var->IsGlobal() )
				case_var->Error("already a global identifier");
			else
				case_var = install_ID(name, current_module.c_str(), false, false);

			add_local(case_var, std::move(type), INIT_NONE, nullptr, nullptr,
			                        VAR_REGULAR);
			(yyval.id) = case_var.release();
			}
#line 4812 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 250: /* for_head: TOK_FOR '(' TOK_ID TOK_IN expr ')'  */
#line 1873 "parse.y"
                        {
			set_location((yylsp[-5]), (yylsp[0]));

			// This rule needs to be separate from the loop
			// body so that we execute these actions - defining
			// the local variable - prior to parsing the body,
			// which might refer to the variable.
			auto loop_var = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( loop_var )
				{
				if ( loop_var->IsGlobal() )
					loop_var->Error("global variable used in for loop");
				}

			else
				{
				loop_var = install_ID((yyvsp[-3].str), current_module.c_str(),
				                                    false, false);
				}

			auto* loop_vars = new IDPList;
			loop_vars->push_back(loop_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 4843 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 251: /* for_head: TOK_FOR '(' '[' local_id_list ']' TOK_IN expr ')'  */
#line 1901 "parse.y"
                        {
			(yyval.stmt) = new ForStmt((yyvsp[-4].id_l), {AdoptRef{}, (yyvsp[-1].expr)});
			}
#line 4851 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 252: /* for_head: TOK_FOR '(' TOK_ID ',' TOK_ID TOK_IN expr ')'  */
#line 1906 "parse.y"
                        {
			set_location((yylsp[-7]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Check for previous definitions of key and
			// value variables.
			auto key_var = lookup_ID((yyvsp[-5].str), module);
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			// Validate previous definitions as needed.
			if ( key_var )
				{
				if ( key_var->IsGlobal() )
					key_var->Error("global variable used in for loop");
				}
			else
				key_var = install_ID((yyvsp[-5].str), module, false, false);

			if ( val_var )
				{
				if ( val_var->IsGlobal() )
					val_var->Error("global variable used in for loop");
				}
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			auto* loop_vars = new IDPList;
			loop_vars->push_back(key_var.release());

			(yyval.stmt) = new ForStmt(loop_vars, {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 4887 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 253: /* for_head: TOK_FOR '(' '[' local_id_list ']' ',' TOK_ID TOK_IN expr ')'  */
#line 1939 "parse.y"
                        {
			set_location((yylsp[-9]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Validate value variable
			auto val_var = lookup_ID((yyvsp[-3].str), module);

			if ( val_var )
				{
				if ( val_var->IsGlobal() )
					val_var->Error("global variable used in for loop");
				}
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			(yyval.stmt) = new ForStmt((yyvsp[-6].id_l), {AdoptRef{}, (yyvsp[-1].expr)}, std::move(val_var));
			}
#line 4909 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 254: /* local_id_list: local_id_list ',' local_id  */
#line 1960 "parse.y"
                        { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 4915 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 255: /* local_id_list: local_id  */
#line 1962 "parse.y"
                        {
			(yyval.id_l) = new IDPList;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 4924 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 256: /* local_id: TOK_ID  */
#line 1970 "parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a global identifier");
				delete [] (yyvsp[0].str);
				}

			else
				{
				(yyval.id) = install_ID((yyvsp[0].str), current_module.c_str(),
				                              false, is_export).release();
				}
			}
#line 4947 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 257: /* $@28: %empty  */
#line 1991 "parse.y"
        { resolving_global_ID = 1; }
#line 4953 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 258: /* global_id: $@28 global_or_event_id  */
#line 1992 "parse.y"
                { (yyval.id) = (yyvsp[0].id); }
#line 4959 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 259: /* $@29: %empty  */
#line 1996 "parse.y"
        { defining_global_ID = 1; }
#line 4965 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 260: /* $@30: %empty  */
#line 1996 "parse.y"
                                              { defining_global_ID = 0; }
#line 4971 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 261: /* def_global_id: $@29 global_id $@30  */
#line 1997 "parse.y"
                { (yyval.id) = (yyvsp[-1].id); }
#line 4977 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 262: /* $@31: %empty  */
#line 2001 "parse.y"
        { resolving_global_ID = 0; }
#line 4983 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 263: /* event_id: $@31 global_or_event_id  */
#line 2002 "parse.y"
                { (yyval.id) = (yyvsp[0].id); }
#line 4989 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 264: /* global_or_event_id: TOK_ID  */
#line 2007 "parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str(), false,
			                    defining_global_ID);
			(yyval.id) = id.release();

			if ( (yyval.id) )
				{
				if ( ! (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a local identifier");

				if ( (yyval.id)->IsDeprecated() )
					{
					const auto& t = (yyval.id)->GetType();

					if ( t->Tag() != TYPE_FUNC ||
					     t->AsFuncType()->Flavor() != FUNC_FLAVOR_FUNCTION )
						reporter->Warning("%s", (yyval.id)->GetDeprecationWarning().c_str());
					}

				delete [] (yyvsp[0].str);
				}

			else
				{
				const char* module_name =
					resolving_global_ID ?
						current_module.c_str() : 0;

				(yyval.id) = install_ID((yyvsp[0].str), module_name,
				                              true, is_export).release();
				}
			}
#line 5027 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 265: /* resolve_id: TOK_ID  */
#line 2045 "parse.y"
                        {
			set_location((yylsp[0]));
			auto id = lookup_ID((yyvsp[0].str), current_module.c_str());
			(yyval.id) = id.release();

			if ( ! (yyval.id) )
				reporter->Error("identifier not defined: %s", (yyvsp[0].str));

			delete [] (yyvsp[0].str);
			}
#line 5042 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 266: /* opt_no_test: TOK_NO_TEST  */
#line 2059 "parse.y"
                        { (yyval.b) = true; }
#line 5048 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 267: /* opt_no_test: %empty  */
#line 2061 "parse.y"
                        { (yyval.b) = false; }
#line 5054 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 268: /* opt_no_test_block: TOK_NO_TEST  */
#line 2065 "parse.y"
                        { (yyval.b) = true; script_coverage_mgr.IncIgnoreDepth(); }
#line 5060 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 269: /* opt_no_test_block: %empty  */
#line 2067 "parse.y"
                        { (yyval.b) = false; }
#line 5066 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 270: /* opt_deprecated: TOK_ATTR_DEPRECATED  */
#line 2071 "parse.y"
                        { (yyval.expr) = new ConstExpr(make_intrusive<StringVal>("")); }
#line 5072 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 271: /* opt_deprecated: TOK_ATTR_DEPRECATED '=' TOK_CONSTANT  */
#line 2074 "parse.y"
                        {
			if ( IsString((yyvsp[0].val)->GetType()->Tag()) )
				(yyval.expr) = new ConstExpr({AdoptRef{}, (yyvsp[0].val)});
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				reporter->Error("'&deprecated=%s' must use a string literal",
				                      d.Description());
				(yyval.expr) = new ConstExpr(make_intrusive<StringVal>(""));
				}
			}
#line 5089 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;

  case 272: /* opt_deprecated: %empty  */
#line 2087 "parse.y"
                        { (yyval.expr) = nullptr; }
#line 5095 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"
    break;


#line 5099 "/builddir/build/BUILD/zeek-4.2.0/amazon-linux-build/src/p.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 2089 "parse.y"


int yyerror(const char msg[])
	{
	if ( in_debug )
		g_curr_debug_error = util::copy_string(msg);

	if ( last_tok[0] == '\n' )
		reporter->Error("%s, on previous line", msg);
	else if ( last_tok[0] == '\0' )
		{
		if ( last_filename )
			reporter->Error("%s, at end of file %s", msg, last_filename);
		else
			reporter->Error("%s, at end of file", msg);
		}
	else
		{
		if ( last_last_tok_filename && last_tok_filename &&
		     ! util::streq(last_last_tok_filename, last_tok_filename) )
			reporter->Error("%s, at or near \"%s\" or end of file %s",
			                      msg, last_tok, last_last_tok_filename);
		else
			reporter->Error("%s, at or near \"%s\"", msg, last_tok);
		}

	return 0;
	}
